#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: EAS.pl,v 1.6.4.2 2003/04/15 18:10:18 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ### Import library subroutines.
  do '/usr/webtool/web-lib.pl';
  &init_config();


  ##############################################################################
  $SUBSYS_DIR        =  '/var/lock/subsys';
  $SYSTEM_LOG        =  '/var/log/messages';
  $AUTH_LOG          =  '/var/log/messages';
  $SNORT_LOG         =  '/var/chroot/snort/log/alert';

  $SNORT_CHROOT_DIR  = '/var/chroot/snort';
  $SNORT_CONF        = '/etc/snort.conf';
  $SNORT_ALERT_FILE  = "$SNORT_CHROOT_DIR/log/alert";

  $FLEXER_PATH       = '/usr/sbin';
  $APACHE_FLEXER     = "$FLEXER_PATH/apache_flexer";
  $IPSEC_FLEXER      = "$FLEXER_PATH/ipsec_flexer";
  $SNORT_FLEXER      = "$FLEXER_PATH/snort_flexer";
  $SYSTEM_FLEXER     = "$FLEXER_PATH/syslog_flexer";

  %EAS_APPLETS = ( 'graphs'      => { weight => 10, name => 'System Graphs' },
                   'services'    => { weight => 20, name => 'Services' },
                   'websites'    => { weight => 30, name => 'Website Logs' },
                   'reports'     => { weight => 40, name => 'System Reports' },
                   'processes'   => { weight => 50, name => 'Process Information' },
                   'syscontrol'  => { weight => 60, name => 'System Control' },
                   'edit_config' => { weight => 99, name => 'Edit Configuration' }
                 );

  %MONTHS = ( 'Dec', 11, 'Nov', 10, 'Oct', 9, 'Sep', 8,
              'Aug', 7,  'Jul', 6,  'Jun', 5,  'May', 4,
              'Apr', 3,  'Mar', 2,  'Feb', 1, 'Jan', 0);

  @MONTHS = ( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
              'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

  ##############################################################################
  sub easMakeSelect() {
    my ($rv);

    $rv  = "<SELECT NAME=\"$_[0]\">\n";
      for (my $i = 2; defined($_[$i]); $i+=2) {
        $rv .= "  <OPTION VALUE=\"$_[$i]\" ";
        $rv .= "SELECTED" if ($_[$i] eq $_[1]);
        $rv .= ">$_[$i+1]</OPTION>\n";
      }
    $rv .= "</SELECT>\n";

    return $rv;
  }

  ##############################################################################
  sub easTruncate() {
    my ($rv, @tmp, $i);

    @tmp = split //, $_[0];

    for ($i = 0; $i < $config{'eas_truncate'} && defined($tmp[$i]); $i++) {
      $rv .= $tmp[$i]; 
    }

    if ($i != length($_[0])) { $rv .= "..."; }

    return $rv;
  }

  ##############################################################################
  sub easStatServices() {
    my (%rv);
      $rv{'CROND'}          = 1 if (-f "$SUBSYS_DIR/crond");
      $rv{'httpd'}          = 1 if (-f "$SUBSYS_DIR/httpd");
      $rv{'kernel'}         = 1 if (1);
      $rv{'ntpd'}           = 1 if (-f "$SUBSYS_DIR/ntpd");
      $rv{'postfix-script'} = 1 if (-f "$SUBSYS_DIR/postfix");
      $rv{'sshd'}           = 1 if (-f "$SUBSYS_DIR/sshd");
      $rv{'syslog-ng'}      = 1 if (-f "$SUBSYS_DIR/syslog-ng");
      $rv{'xinetd'}         = 1 if (-f "$SUBSYS_DIR/xinetd");
    return %rv;
  }

  ##############################################################################
  sub easHeader() {
    my $TABLE_WIDTH = "100%";
    my $REFRESH = '';

    # Set up the appropriate refresh rate.
    if (! $_[0]) {
      $REFRESH = "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"$config{'eas_refresh'}\">";
    }
    if ($_[0] == 1) {
      $REFRESH  = "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"300\">\n";
      $REFRESH .= "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
      $REFRESH .= "<META HTTP-EQUIV=\"Cache-Control\" content=\"no-cache\">\n";
    }
    if ($_[0] == 2) {
      $REFRESH = undef;
    }

    # Finally print it out.
    print <<EOF;
Content-type: text/html

<HTML>
  <HEAD>
    <TITLE>EnGarde Auditing System</TITLE>
    $REFRESH

    <STYLE TYPE="text/css">
      A:link     { text-decoration: none; color: #800000; }
      A:visited  { text-decoration: none; color: #800000; }
      A:active   { text-decoration: none; color: #800000; }
      A:hover    { color: #CCCCCC;                        }

      PRE        { font-family: Courier }
      .tbody     { margin-left: 10px; }
      .tbody     { margin-left: 10px; }

      BODY,TH,P,FONT,LI,UL,BLOCKQUOTE,A,TABLE,I {
        font-family: Arial, Helvetica, Sans-Serif; font-size: 10pt }

      .thead     { font-family: Arial, Helvetica, Sans-Serif;
                   font-size: 10pt; color: #ffffff; margin-left: 10px; }

      .rhead     { font-family: Arial, Helvetica, Sans-Serif;
                    font-size: 10pt; color: #ffffff; }

      .ttitle    { font-family: Arial, Helvetica, Sans-Serif;
                    font-size: 14pt; color: #ffffff; margin-left: 10px; }

      .nbody     { font-family: Arial, Helvetica, Sans-Serif;
                    font-size: 10pt; margin-left: 10px; margin-right: 10px; }

      .toolfont  { font-family: Arial, Helvetica, Sans-Serif;
                   font-size: 10pt; }

      .toolfont2 { font-family: Arial, Helvetica, Sans-Serif;
                   margin-left: 15px;
                   font-size: 10pt; }

      .log       { font-family: Courier;
                   margin-left: 15px;
                   font-size: 10pt; }
    </STYLE>
  </HEAD>

  <BODY BGCOLOR="#F4F4F4" LINK="#0000EE" VLINK="#0000EE" TEXT="#000000">
EOF
  }


  ##############################################################################
  sub easFooter() {
    print <<EOF;
  </BODY>
</HTML>
EOF
  }
