#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: applet_graphs.cgi,v 1.1 2002/04/25 00:45:20 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and get our input variables.  Bring MRTG too.
  require 'EAS.pl';
  require 'mrtg/mrtg-lib.pl';
  &ReadParse();

  # Print standard header.
  &easHeader(1);

  # Both individual and "index" situations need to be in a table.
  print "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";

  # We are displaying H/D/W/M graph for a SPECIFIC item.
  if ($in{'name'}) {
    my $GRAPH = undef;
    my $DESC  = undef;

    # Print a link to go back.
    print <<EOF;
  <TR $cb>
    <TD COLSPAN="4">
      <A HREF="applet_graphs.cgi"><B>[&nbsp;$text{'go_back'}&nbsp;]</B></A>
    </TD>
  <TR>

  <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

EOF

    # Get this particular graphs MRTG object.
    foreach $G (@MRTG_GRAPHS) {
      if ($G->{'name'} eq $in{'name'}) {
        $GRAPH = $G; $DESC = "&nbsp;$G->{'desc'}";
      }
    }

    # Print daily/weekly/monthly/hourly blocks for this object.
    &mrtgPrintBlock('d', $GRAPH);
    &mrtgPrintBlock('w', $GRAPH);
    &mrtgPrintBlock('m', $GRAPH);
    &mrtgPrintBlock('y', $GRAPH);
  }

  # The "Index" case: iterate over each MRTG item, printing as we go.
  else {
    foreach my $G (sort { $a->{'disp'} <=> $b->{'disp'} } @MRTG_GRAPHS) {
      next if (! $G->{'disp'});
      &mrtgPrintBlock('d', $G, 1);
    }
  }

  # Close the table.
  print "</TABLE>\n";

  # Print standard footer.
  &easFooter();
