#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: applet_processes.cgi,v 1.2 2002/05/08 18:34:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and get our input variables.
  require 'EAS.pl';
  &ReadParse();

  # Print SMS header.
  &easHeader();

  # Print the top stanza.
  print <<EOF;
  <FORM NAME="applet" ACTION="applet_processes.cgi">
  <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">

  <TR $cb>
    <TD COLSPAN="4"><DIV CLASS="nbody">
      <B>Sort By:&nbsp;
      <A HREF="applet_processes.cgi?sort_user=1">[&nbsp;User&nbsp;]</A>
      <A HREF="applet_processes.cgi?sort_cpu=1">[&nbsp;%CPU&nbsp;]</A>
      <A HREF="applet_processes.cgi?sort_mem=1">[&nbsp;%Memory&nbsp;]</A>
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

  <TR $tb>
    <TD><DIV CLASS="thead"><B>User</B></DIV></TD>
    <TD><DIV CLASS="thead"><B>%&nbsp;CPU</B></DIV></TD>
    <TD><DIV CLASS="thead"><B>%&nbsp;Memory</B></DIV></TD>
    <TD><DIV CLASS="thead"><B>Command</B></DIV></TD>
  </TR>
EOF

  # Get our process list.
  my @PROCESSES = &easListProcesses;

  # Sort the processes if we were asked to.
  if ($in{'sort_user'}) {
    @PROCESSES = sort { $a->{'USER'} cmp $b->{'USER'} } @PROCESSES;
  }
  elsif ($in{'sort_cpu'}) {
    @PROCESSES = sort { $b->{'%CPU'} cmp $a->{'%CPU'} } @PROCESSES;
  }
  elsif ($in{'sort_mem'}) {
    @PROCESSES = sort { $b->{'%MEM'} <=> $a->{'%MEM'} } @PROCESSES;
  }

  # Find out how many lines we should display.
  my $LINES = @PROCESSES;
  $LINES = $config{'eas_lines'} if ($config{'eas_lines'});

  # Finally show the info.
  for (my $i = 0; $i < $LINES; $i++) {
    print <<EOF;
  <TR $cb>
    <TD><DIV CLASS="log">$PROCESSES[$i]->{'USER'}</DIV></TD>
    <TD><DIV CLASS="log">$PROCESSES[$i]->{'%CPU'}</DIV></TD>
    <TD><DIV CLASS="log">$PROCESSES[$i]->{'%MEM'}</DIV></TD>
    <TD><DIV CLASS="log">$PROCESSES[$i]->{'COMMAND'}</DIV></TD>
  </TR>
EOF
  }

  # Close the inner table and print SMS footer.
  print "  </TABLE>\n  </FORM>\n";
  &easFooter('processes');

################################################################################
sub easListProcesses() {
  my @RV = ();

  open PS, "ps auxw |";
    my $tmp = <PS>;	# Skip the first line (the column headings.)

    while (my $line = <PS>) {
      chomp $line; my @T = split /\s+/, $line, 11;

      $T[10] = &easTruncate($T[10]);

      push @RV, { 'USER' => $T[0], 'PID' => $T[1], '%CPU' => $T[2],
                  '%MEM' => $T[3], 'VSZ' => $T[4], 'RSS' => $T[5],
                  'TTY' => $T[6], 'STAT' => $T[7], 'START' => $T[8],
                  'TIME' => $T[9], 'COMMAND' => $T[10] };
    }
  close PS;

  return @RV;
}
