#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: applet_services.cgi,v 1.6 2003/03/03 15:58:54 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and get our input variables.
  require 'EAS.pl';
  &ReadParse();

  # Print standard header.
  &easHeader();

  # Define what services we know about.  Add to this array as necessary.
  @EAS_SERVICES = (
    { 'svc'    => 'crond', 'desc'   => 'Cron Daemon',
      'logstr' => 'CROND', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'dhcpd', 'desc'   => 'DHCP Server',
      'logstr' => 'dhcpd', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'ftp', 'desc'   => 'FTP Server',
      'logstr' => 0,     'xinetd' => 1, 'useport' => 0 },

    { 'svc'    => 'httpd', 'desc'   => 'Web Server',
      'logstr' => 'httpd', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'ldap',  'desc'   => 'LDAP Server',
      'logstr' => 'slapd', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'named', 'desc'   => 'DNS Server',
      'logstr' => 'named', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'postfix', 'desc'   => 'Mail Server',
      'logstr' => 'postfix', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'pptpd', 'desc'   => 'PPTP Server',
      'logstr' => 'pptpd', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'samba', 'desc'   => 'Windows File Sharing',
      'logstr' => 'samba', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'stunnel-imap', 'desc'   => 'SIMAP Server',
      'logstr' => 'stunnel',      'xinetd' => 0, 'useport' => 993 },

    { 'svc'    => 'stunnel-pop3', 'desc'   => 'SPOP3 Server',
      'logstr' => 'stunnel',      'xinetd' => 0, 'useport' => 995 },

    { 'svc'    => 'squid', 'desc'   => 'Caching Proxy',
      'logstr' => 'squid', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'sshd', 'desc'   => 'Secure Shell Daemon',
      'logstr' => 'sshd', 'xinetd' => 0, 'useport' => 0 },

    { 'svc'    => 'userpass', 'desc'   => 'User Password Changer',
      'logstr' => 0,          'xinetd' => 0, 'useport' => 0 } );



  #
  # If we are given a service then do some janitorial stuff.
  #
  my ($SERVICE, $CURRENTLY_STRING, $ATBOOT_STRING);

  if ($in{'svc'}) {
    # Get the @EAS_SERVICES entry for this $in{'svc'}.
    foreach my $s (@EAS_SERVICES) {
      $SERVICE = $s if ($s->{'svc'} eq $in{'svc'});
    }

    # Generate $CURRENTLY_STRING.
    if (&easIsServiceActive($SERVICE->{'svc'}, $SERVICE->{'xinetd'}, $SERVICE->{'useport'})) {
      $CURRENTLY_STRING  = "<FONT COLOR=\"GREEN\">Enabled</FONT>";
    }
    else { $CURRENTLY_STRING = "<FONT COLOR=\"RED\">Disabled</FONT>"; }
    $CURRENTLY_STRING .= "&nbsp;&nbsp;";
    $CURRENTLY_STRING .= "<B><A HREF=\"do_services.cgi?";
    $CURRENTLY_STRING .= "service=$SERVICE->{'svc'}&";
    $CURRENTLY_STRING .= "xinetd=$SERVICE->{'xinetd'}&";
    $CURRENTLY_STRING .= "useport=$SERVICE->{'useport'}&";
    $CURRENTLY_STRING .= "type=now\">[&nbsp;Toggle&nbsp;]";
    $CURRENTLY_STRING .= "</A></B>\n";

    # Generate $ATBOOT_STRING.
    $ATBOOT_STRING = $CURRENTLY_STRING;
    if (! $SERVICE->{'xinetd'}) {
      if (&easIsServiceActiveAtBoot($SERVICE->{'svc'}, $SERVICE->{'xinetd'})) {
        $ATBOOT_STRING  = "<FONT COLOR=\"GREEN\">Enabled</FONT>";
      }
      else { $ATBOOT_STRING = "<FONT COLOR=\"RED\">Disabled</FONT>"; }
      $ATBOOT_STRING .= "&nbsp;&nbsp;";
      $ATBOOT_STRING .= "<B><A HREF=\"do_services.cgi?";
      $ATBOOT_STRING .= "service=$SERVICE->{'svc'}&";
      $ATBOOT_STRING .= "xinetd=$SERVICE->{'xinetd'}&";
      $ATBOOT_STRING .= "type=boot\">[&nbsp;Toggle&nbsp;]</A></B>\n";
    }
  }

  # Generate $SERVICES_SELECT.
  my $SERVICES_SELECT  = "<SELECT NAME=\"service\" SIZE=\"1\" onChange=\"";
  $SERVICES_SELECT    .= "location=applet.service[applet.service.";
  $SERVICES_SELECT    .= "selectedIndex].value\">\n";
  foreach my $k (sort { $a->{'desc'} cmp $b->{'desc'} } @EAS_SERVICES) {
    next if (! $k->{'xinetd'} && ! -f "/etc/init.d/$k->{'svc'}");

    $SERVICES_SELECT .= "  <OPTION VALUE=\"applet_services.cgi?svc=$k->{'svc'}\" ";
    $SERVICES_SELECT .= "SELECTED" if ($k->{'svc'} eq $in{'svc'});
    $SERVICES_SELECT .= ">$k->{'desc'}</OPTION>\n";
  }
  $SERVICES_SELECT .= "</SELECT>\n";

  # Print the top stanza.
  print <<EOF;
  <FORM NAME="applet" ACTION="applet_services.cgi">
  <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
  <TR $cb>
    <TD><DIV CLASS="nbody"><B>Service:</B></DIV>
    <TD> $SERVICES_SELECT </TD>
  </TR>

EOF

  #
  # Only show this stuff if we have actually chosen a service.
  #
  if ($in{'svc'}) {
    print <<EOF;
  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>Currently:</B></DIV>
    <TD><DIV CLASS="toolfont"><B>$CURRENTLY_STRING</B></DIV></TD>
  </TR>
  <TR $cb>
    <TD><DIV CLASS="nbody"><B>At Boot:</B></DIV>
    <TD><DIV CLASS="toolfont"><B>$ATBOOT_STRING</B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

EOF

    #
    # Only continue if we can get logs for this service.
    #
    if ($SERVICE->{'logstr'}) {
      print <<EOF;
  <TR $tb>
    <TD WIDTH="100"><DIV CLASS="thead"><B>Date</B></DIV>
    <TD><DIV CLASS="thead"><B>Message</B></DIV>
  </TR>
EOF

      # Get our log lines and determine how many lines to print.
      my @LOG_LINES = &easParseLog($SERVICE->{'logstr'});
      my $LINES = @LOG_LINES - $config{'eas_lines'};
      $LINES = 0 if (@LOG_LINES <= $config{'eas_lines'});

      # Print up to $LINES lines, in reverse, of the log lines.
      for (my $i = @LOG_LINES - 1; $i >= $LINES; $i--) {
        if ($LOG_LINES[$i]->{'MESSAGE'} && $LOG_LINES[$i]->{'MESSAGE'}) {
          print <<EOF;
  <TR $cb>
    <TD><DIV CLASS="log">$LOG_LINES[$i]->{'DATE'}</DIV></TD>
    <TD><DIV CLASS="log">$LOG_LINES[$i]->{'MESSAGE'}</DIV></TD>
  </TR>
EOF
        }
      }
    }

  }

  # Close the inner table and print standard footer.
  print "  </TABLE>\n  </FORM>\n";
  &easFooter();

################################################################################
sub easIsServiceActiveAtBoot() {
  my $SERVICE = shift;
  my $XINETD = shift;

  open CHKCONFIG, "chkconfig --list $SERVICE |";
    my $LINE = <CHKCONFIG>;
  close CHKCONFIG;

  if ($XINETD) {
    if ($LINE =~ m/\s+on$/) { return 1; }
    else                    { return 0; }
  }
  else {
    if ($LINE =~ m/\s+3\:on\s+/) { return 1; }
    else                         { return 0; }
  }

  # NOT REACHED
}

################################################################################
sub easIsServiceActive() {
  my $SERVICE = shift;
  my $XINETD = shift;
  my $PORT = shift;

  if ($XINETD) {
    open CHKCONFIG, "chkconfig --list $SERVICE |";
      my $LINE = <CHKCONFIG>;
    close CHKCONFIG;

    if ($LINE =~ m/\s+on$/) { return 1; }
    else                    { return 0; }
  }
  elsif ($PORT) {
    return `netstat --inet -an | grep \:$PORT`;
  }
  else {
    open INITSCRIPT, "/etc/init.d/$SERVICE status |";
      my $STATUS = <INITSCRIPT>; chomp $STATUS;
    close INITSCRIPT;

    if ($STATUS =~ m/is\ running/) { return 1; }
    return 0;
  }

  # NOT REACHED
}

################################################################################
sub easParseLog() {
  my @RV = ();

  open LOG, "$SYSTEM_FLEXER -f $SYSTEM_LOG -s $_[0] |";
    while (<LOG>) {
      chomp;
      my @TMP =  split /\|/, $_;

      $TMP[5] =~ s/\ \HTTP.*//;
      my $MESSAGE = &easTruncate($TMP[5]); $MESSAGE =~ s/\s+/&nbsp;/g;

      push @RV, { 'DATE' => "$MONTHS{$TMP[0]}/$TMP[1]&nbsp;$TMP[2]",
                  'HOST' => $TMP[3], 'MESSAGE' => $MESSAGE };
    }
  close LOG;

  return @RV;
}
