#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: applet_websites.cgi,v 1.2 2002/05/08 18:32:21 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and get our input variables.
  require 'EAS.pl';
  &ReadParse();

  # Print SMS header.
  &easHeader();

  # Create $WEBSITES_SELECT
  my $WEBSITES_SELECT  = "<SELECT NAME=\"website\" SIZE=\"1\" onChange=\"";
  $WEBSITES_SELECT    .= "location=applet.website[applet.website.";
  $WEBSITES_SELECT    .= "selectedIndex].value\">\n";

  foreach my $l (&easGetWebLogs()) {
    $WEBSITES_SELECT .= "  <OPTION VALUE=\"applet_websites.cgi?website=$l->{'LOG'}\" ";
    $WEBSITES_SELECT .= "SELECTED" if ($l->{'LOG'} eq $in{'website'});
    $WEBSITES_SELECT .= ">$l->{'SITE'}</OPTION>\n";
  }
  $WEBSITES_SELECT .= "</SELECT>\n";

  # Print the top stanza.
  print <<EOF;
  <FORM NAME="applet" ACTION="applet_websites.cgi">
  <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
  <TR $cb>
    <TD COLSPAN="3"><DIV CLASS="nbody"><B>Web Site:</B> $WEBSITES_SELECT </TD>
  </TR>

EOF

  #
  # If we were handed a log, then print it.
  #
  if ($in{'website'}) {
    print <<EOF;
  <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

  <TR $tb>
    <TD WIDTH="100"><DIV CLASS="thead"><B>Date</B></DIV>
    <TD><DIV CLASS="thead"><B>Host</B></DIV>
    <TD><DIV CLASS="thead"><B>Request</B></DIV>
  </TR>

EOF

    # Get our log lines and determine how many lines to print.
    my @LOG_LINES = &easParseLog($in{'website'});
    my $LINES = @LOG_LINES - $config{'eas_lines'} - 1;
    $LINES = 0 if (@LOG_LINES <= $config{'eas_lines'});

    # Print up to $LINES lines, in reverse, of the log lines.
    for (my $i = @LOG_LINES - 1; $i >= $LINES; $i--) {
      print <<EOF;
  <TR $cb>
    <TD><DIV CLASS="log">$LOG_LINES[$i]->{'DATE'}</DIV>
    <TD><DIV CLASS="log">$LOG_LINES[$i]->{'HOST'}</DIV>
    <TD><DIV CLASS="log">$LOG_LINES[$i]->{'REQUEST'}</DIV>
  </TR>

EOF
    }
  }

  # Print SMS footer.
  print "</TABLE>\n";
  &easFooter();

################################################################################
sub easGetWebLogs() {
  my @RV = ();

  opendir HTTPD, "/home/httpd";
    foreach my $f (grep {-f "/home/httpd/$_/logs/access_log"} readdir(HTTPD)) {
      my ($FQDN, $PORT) = split /\-/, $f;
      if ($PORT == 80)     { $SITE = "http://$FQDN/";  }
      elsif ($PORT == 443) { $SITE = "https://$FQDN/"; }
      else { next; }

      push @RV, { 'SITE' => $SITE, 'LOG'  => "/home/httpd/$f/logs/access_log" };
    }
  closedir HTTPD;

  return @RV;
}

################################################################################
sub easParseLog() {
  my @RV = ();

  open LOG, "$APACHE_FLEXER -f $_[0] |";
    while (<LOG>) {
      chomp;
      my @TMP =  split /\|/, $_;

      $TMP[7] =~ s/\ \HTTP.*//;
      my $MESSAGE = &easTruncate($TMP[7]); $MESSAGE =~ s/\s+/&nbsp;/g;

      push @RV, { 'DATE' => "$MONTHS{$TMP[4]}/$TMP[3]&nbsp;$TMP[6]",
                  'HOST' => $TMP[0], 'REQUEST' => $MESSAGE };
    }
  close LOG;

  return @RV;
}
