#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_services.cgi,v 1.2 2002/05/07 14:19:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and get our input variables.
  require 'EAS.pl';
  &ReadParse();

  #
  # We're dealing with a running service.
  #
  if ($in{'type'} eq 'now') {
    if (&easIsServiceActive($in{'service'}, $in{'xinetd'}, $in{'useport'})) {
      &easToggleRunningService($in{'service'}, $in{'xinetd'}, 'stop');
    }
    else {
      &easToggleRunningService($in{'service'}, $in{'xinetd'}, 'start');
    }

  }

  #
  # We're dealing with a bootable service.
  #
  elsif ($in{'type'} eq 'boot') {

    if (&easIsServiceActiveAtBoot($in{'service'}, $in{'xinetd'})) {
      &easToggleBootableService($in{'service'}, '--del');
    }
    else {
      &easToggleBootableService($in{'service'}, '--add');
    }

  }

  # Go back.
  &redirect("applet_services.cgi?svc=$in{'service'}");


################################################################################
sub easIsServiceActiveAtBoot() {
  my $SERVICE = shift;
  my $XINETD = shift;

  open CHKCONFIG, "chkconfig --list $SERVICE |";
    my $LINE = <CHKCONFIG>;
  close CHKCONFIG;

  if ($XINETD) {
    if ($LINE =~ m/\s+on$/) { return 1; }
    else                    { return 0; }
  }
  else {
    if ($LINE =~ m/\s+3\:on\s+/) { return 1; }
    else                         { return 0; }
  }

  # NOT REACHED
}

################################################################################
sub easIsServiceActive() {
  my $SERVICE = shift;
  my $XINETD = shift;
  my $PORT = shift;

  if ($XINETD) {
    open CHKCONFIG, "chkconfig --list $SERVICE |";
      my $LINE = <CHKCONFIG>;
    close CHKCONFIG;

    if ($LINE =~ m/\s+on$/) { return 1; }
    else                    { return 0; }
  }
  elsif ($PORT) {
    my $RV = `netstat --inet -an | grep \:$PORT | wc -l`;

    chomp $RV; $RV =~ s/\s+//g;

    return $RV;
  }
  else {
    open INITSCRIPT, "/etc/init.d/$SERVICE status |";
      my $STATUS = <INITSCRIPT>; chomp $STATUS;
    close INITSCRIPT;

    if ($STATUS =~ m/is\ running/) { return 1; }
    return 0;
  }

  # NOT REACHED
}

################################################################################
sub easParseLog() {
  my @RV = ();

  open LOG, "$SYSTEM_FLEXER -f $SYSTEM_LOG -s $_[0] |";
    while (<LOG>) {
      chomp;
      my @TMP =  split /\|/, $_;

      $TMP[5] =~ s/\ \HTTP.*//;
      my $MESSAGE = &easTruncate($TMP[5]); $MESSAGE =~ s/\s+/&nbsp;/g;

      push @RV, { 'DATE' => "$MONTHS{$TMP[0]}/$TMP[1]&nbsp;$TMP[2]",
                  'HOST' => $TMP[3], 'MESSAGE' => $MESSAGE };
    }
  close LOG;

  return @RV;
}

################################################################################
sub easToggleRunningService() {
  my $SERVICE = shift;
  my $XINETD = shift;
  my $FCN = shift;
  my $RC;

  if (! $XINETD) {
    %E   = %ENV; %ENV = ();
    $RC  = system "/etc/init.d/$SERVICE $FCN > /dev/null 2>&1";
    %ENV = %E;
  }
  else {
    &easToggleXinetdService($SERVICE, $FCN);
  }

  return $RC;
}

################################################################################
sub easToggleBootableService() {
  my $SERVICE = shift;
  my $FCN = shift;
  my $RC;

  $RC = system "chkconfig $SERVICE $FCN > /dev/null 2>&1";

  return $RC;
}

################################################################################
sub easToggleXinetdService() {
  my $SERVICE = shift;
  my $FCN = shift;
  my $RC;

  my $lref = &read_file_lines("/etc/xinetd.d/$SERVICE");

  for (my $i = 0; $i < @$lref; $i++) {
    if (@$lref[$i] =~ m/^.*disable\s+\=/) {
      if ($FCN eq 'start')   { @$lref[$i] = "\t# disable\t\t= yes"; }
      elsif ($FCN eq 'stop') { @$lref[$i] = "\tdisable\t\t= yes"; }
    }
  }

  &flush_file_lines();

  %E   = %ENV; %ENV = ();
  $RC  = system "/etc/init.d/xinetd restart > /dev/null 2>&1";
  %ENV = %E;

  return $RC;
}
