#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: do_edit_config.cgi,v 1.6 2002/09/05 21:03:31 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our library routines and populate %in.
  require "ids-lib.pl";
  &ReadParse();

  #
  # Update the snort.conf.
  #
  my $lref  =  &read_file_lines("/var/chroot/snort/etc/snort.conf");
  for (my $i = 0; $i < @$lref; $i++) { 
    my ($line); $line = @$lref[$i];

    # Update HOME_NET.
    if ($line =~ m/^var\ HOME_NET\ /) {
      my $val;

      if ($in{'HOME_NET'}) {
        $val = '[';
        foreach my $V (split /\r\n/, $in{'HOME_NET_value'}) { $val .= "$V,"; }
        $val =~ s/\,$//;
        $val .= ']';
      }
      else { $val = 'any'; }

      @$lref[$i] = "var HOME_NET $val";
    }

    # Update DNS_SERVERS.
    elsif ($line =~ m/^var\ DNS_SERVERS\ /) {
      my $val;

      if ($in{'DNS_SERVERS'}) {
        $val = '[';
        foreach my $V (split /\r\n/, $in{'DNS_SERVERS_value'}) { $val .= "$V,"; }
        $val =~ s/\,$//;
        $val .= ']';
      }
      else { $val = '$HOME_NET'; }

      @$lref[$i] = "var DNS_SERVERS $val";
    }

    # Update HTTP_SERVERS.
    elsif ($line =~ m/^var\ HTTP_SERVERS\ /) {
      my $val;

      if ($in{'HTTP_SERVERS'}) {
        $val = '[';
        foreach my $V (split /\r\n/, $in{'HTTP_SERVERS_value'}) { $val .= "$V,"; }
        $val =~ s/\,$//;
        $val .= ']';
      }
      else { $val = '$HOME_NET'; }

      @$lref[$i] = "var HTTP_SERVERS $val";
    }

    #
    # We have an include directive. Check it if we feel like it. (bewm bewm)
    #
    elsif ($line =~ m/^[#\ ]*include\ \$RULE_PATH\/(.+)\.rules$/) {
      if ($in{"rule_$1"} || $RULES_ALWAYS_ON{$1}) {
        @$lref[$i] = "include \$RULE_PATH/$1.rules";
      }
      else { @$lref[$i] = "# include \$RULE_PATH/$1.rules"; }
    }
  }


  #
  # Update snort.conf.gd.
  #
  open GDCONF, '>/var/chroot/snort/etc/snort.conf.gd';
    if ($in{'SNORT_INTERFACE'}) {
      print GDCONF "SNORT_INTERFACE=$in{'SNORT_INTERFACE'}\n";
    }
  close GDCONF;


  # Save the files and go back to the index page.
  &flush_file_lines();
  &redirect("index.cgi");

