#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: ids-lib.pl,v 1.9 2002/09/05 21:03:31 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  do "../../web-lib.pl";
  &init_config();

  ##############################################################################
  %RULES_ALWAYS_ON = ('info' => '1', 'local' => '1', 'policy' => '1');


  ##############################################################################
  sub idsMakeAddressInput($$) {
    my $NAME   = shift;
    my $VALUE  = shift;
    my $NETBOX = shift;
    my $RV;

    # "Local Addresses" row.
    $RV  = "<INPUT TYPE=\"RADIO\" NAME=\"$NAME\" VALUE=\"0\" ";
    $RV .= (($VALUE eq '$HOME_NET' || $VALUE eq 'any')) ? 'CHECKED' : "";
    $RV .= ">&nbsp;Local ";
    $RV .= ($NETBOX) ? 'Networks' : 'Addresses';

    # "Specify Addresses" row.
    $RV .= "<BR><INPUT TYPE=\"RADIO\" NAME=\"$NAME\" VALUE=\"1\" ";
    $RV .= (($VALUE ne '$HOME_NET' && $VALUE ne 'any')) ? 'CHECKED' : "";
    $RV .= ">&nbsp;Specify ";
    $RV .= ($NETBOX) ? 'Network(s)' : 'Addresse(s)';

    $RV .= "\n<TEXTAREA NAME=\"$NAME";
    $RV .= "_value\" WRAP ROWS=\"2\" COLS=\"";
    $RV .= ($NETBOX) ? 18 : 15;
    $RV .= "\">";

    # Short circuit if we have $HOME_NET.
    goto bewm if (($VALUE eq '$HOME_NET' || $VALUE eq 'any'));

      # Single address.
      if ($VALUE =~ m/^[0-9\.]+$/) { $RV .= "$VALUE"; }

      # Multiple addresses.
      else {
        $VALUE =~ s/^\[//; $VALUE =~ s/\]$//;
        foreach my $ip (split /\,/, $VALUE) { $RV .= "$ip\n"; }
      }

bewm:
    $RV .= "</TEXTAREA>\n";

    return $RV;
  }
  ##############################################################################
  sub idsReadConfiguration() {
    my %RV;

    open SNORTCONF, "/var/chroot/snort/etc/snort.conf";
    while (<SNORTCONF>) {
      chomp $_;

      if ($_ =~ m/^var\ ([^\ ]+)\ (.+)$/)  {
        $RV{$1} = $2;
      }
      elsif ($_ =~ m/^include\ ([^\ ]+)$/) {
        $key = `basename "$1" .rules`; chomp $key;
        $RV{"rule_$key"} = 1;
      }
    }
    close SNORTCONF;

    # Read _our_ conf.
    open GDCONF, '/var/chroot/snort/etc/snort.conf.gd' or return %RV;
    while (my $line = <GDCONF>) {
      chomp $line;

      my @TMP = split /\=/, $line, 2;
      $RV{$TMP[0]} = $TMP[1];
    }
    close GDCONF;

    return %RV;
  }

  ##############################################################################
  sub idsStatus() {
    my $STATUS = `/etc/init.d/snortd status 2>&1`;

    return 1 if ($STATUS =~ /is\ running\.\.\./);
    return 0;
  }

  ##############################################################################
  1;
