#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: list_reports.cgi,v 1.2.4.3 2003/04/22 09:24:52 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import all our library routines.
  require "ids-lib.pl";

  # Print the standard header.
  &header("IDS Management :: Graphs and Reports", 0, 0);

  $REPORT_PATH  = "/home/httpd/html/system/ids";
  $DAILY_PATH   = "$REPORT_PATH/daily";
  $WEEKLY_PATH  = "$REPORT_PATH/weekly";
  $MONTHLY_PATH = "$REPORT_PATH/monthly";

  #
  # bewm.
  #
  my $BASE_PIE_LINK = "<A onClick='window.open(\"show_eval_pie_graph.cgi\", \"ids_graph_Y\", \"toolbar=no,menubar=yes,scrollbars=yes,width=550,height=600,resizable=yes\"); return false' HREF=\"#\">";
  my $BASE_BAR_LINK = "<A onClick='window.open(\"show_eval_bar_graph.cgi\", \"ids_graph_Y\", \"toolbar=no,menubar=yes,scrollbars=yes,width=550,height=600,resizable=yes\"); return false' HREF=\"#\">";

  my $pie_link_protoname = $BASE_PIE_LINK;
  my $bar_link_protoname = $BASE_BAR_LINK;
  my $pie_link_classname = $BASE_PIE_LINK;
  my $bar_link_classname = $BASE_BAR_LINK;
  my $pie_link_bottom10  = $BASE_PIE_LINK;
  my $bar_link_bottom10  = $BASE_BAR_LINK;
  my $pie_link_top10     = $BASE_PIE_LINK;
  my $bar_link_top10     = $BASE_BAR_LINK;
  my $pie_link_dport     = $BASE_PIE_LINK;
  my $bar_link_dport     = $BASE_BAR_LINK;

  #
  # Grab daily, weekly and monthly report list
  #
  my $tmp;
  $tmp = `date -d yesterday "+%a %b. %d, %Y"`; chomp $tmp;
  $DRL = "  <OPTION>$tmp</OPTION>\n"; 

  $tmp = `date -d "last sunday" "+%b. %d, %Y"`; chomp $tmp;
  $WRL = "  <OPTION>$tmp</OPTION>\n"; 

  $tmp = `date -d yesterday "+%B %Y"`; chomp $tmp;
  $MRL = "  <OPTION>$tmp</OPTION>\n"; 


  # Print the HTML stuff.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      IDS Management :: Graphs and Reports
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you may view up-to-date IDS reports.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR BGCOLOR=#717171>
        <TD><DIV CLASS="thead">
          <B>Graph Report Type</B>
        </DIV></TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER" COLSPAN="2">
          <DIV CLASS="thead"><b>Graph/Chart Type</b></DIV>
        </TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>


      <TR>
        <TD><DIV CLASS="nbody">
          <B>Attacks By Protocol</B><BR>
          Display current activity for TCP, UDP, and ICMP </DIV>
        </TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$bar_link_protoname
          <img src="/images/bar_icon.png" border=0></A></B>
        </DIV></TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$pie_link_protoname
          <img src="/images/pie_icon.png" border=0></A></B>
        </DIV></TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>



      <TR>
        <TD><DIV CLASS="nbody">
          <B>Attacks By Alert Class</B><BR>
          Total number of attacks of each classification 
        </DIV></TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$bar_link_classname
          <img src="/images/bar_icon.png" border=0></A></B>
        </DIV></TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$pie_link_classname
          <img src="/images/pie_icon.png" border=0></A></B>
        </DIV></TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>



      <TR>
        <TD><DIV CLASS="nbody">
          <B>Ten Least Common Attacks</B><BR>
          View least frequently occuring attacks 
        </DIV></TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$bar_link_bottom10
          <img src="/images/bar_icon.png" border=0></A></B>
        </DIV></TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$pie_link_bottom10
          <img src="/images/pie_icon.png" border=0></A></B>
        </DIV></TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>



      <TR>
        <TD><DIV CLASS="nbody">
          <B>Ten Most Common Attacks</B><BR>
          View most frequently occuring attacks 
        </DIV></TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$bar_link_top10
          <img src="/images/bar_icon.png" border=0></A></B>
        </DIV></TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$pie_link_top10
          <img src="/images/pie_icon.png" border=0></A></B>
        </DIV></TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>


      <TR>
        <TD><DIV CLASS="nbody">
          <B>Ten Most Ports Attacked</B><BR>
          View most frequently attacked destination ports
        </DIV></TD>
        <TD> &nbsp; </TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$bar_link_dport
          <img src="/images/bar_icon.png" border=0></A></B>
        </DIV></TD>

        <TD ALIGN="CENTER"><DIV CLASS="nbody">
          <B>$pie_link_dport
          <img src="/images/pie_icon.png" border=0></A></B>
        </DIV></TD>
      </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="4"> &nbsp; </TD> </TR>
    </TABLE>


   
    <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="ttitle"><B>
          IDS Report Archives
        </B></DIV></TD>
      </TR>

      <TR> <TD COLSPAN="3">Below you can select to view reports from previous
        days, months and weeks.  Daily reports are archived for up to 30 days,
        weekly reports for 3 months and 1 year for monthly reports.
      </TD></TR>

      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="98%" ALIGN="RIGHT">
        <TR BGCOLOR="#717171">
          <TD COLSPAN="2"><DIV CLASS="thead"><B>
            Daily Reports
          </B></DIV></TD>
  
          <TD COLSPAN="2"><DIV CLASS="thead"><B>
            Weekly Reports
          </B></DIV></TD>
  
          <TD COLSPAN="2"><DIV CLASS="thead"><B>
            Monthly Reports
          </B></DIV></TD>
        </TR>
        
        <TR> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <FORM ACTION="do_ids_archive.cgi" METHOD="POST">
        <TR>
          <TD ALIGN="RIGHT">
            <SELECT NAME="daily" SIZE="1">
              <OPTION>-- Choose Report --</OPTION>
              $DRL
            </SELECT>
          </TD>
          <TD>
            <INPUT TYPE="submit" NAME="daily_s" VALUE="View">
          </TD>
        
          <TD ALIGN="RIGHT">
            <SELECT NAME="weekly" SIZE="1">
              <OPTION>-- Choose Report --</OPTION>
              $WRL
            </SELECT>
          </TD>
          <TD ALIGN="LEFT">
            <INPUT TYPE="submit" NAME="weekly_s" VALUE="View">
          </TD>

          <TD ALIGN="RIGHT">
            <SELECT NAME="monthly" SIZE="1">
              <OPTION>-- Choose Report --</OPTION>
              $MRL
            </SELECT>
          </TD>
          <TD>
            <INPUT TYPE="submit" NAME="monthly_s" VALUE="View">
          </TD>
        </TR>
        </FORM>

        <TR> <TD COLSPAN="6"> &nbsp; </TD> </TR>

      </TABLE>

  </TABLE>
</CENTER><P>
EOF

  # Print the standard footer.
  &ryanFooter("/Security/ids/");
