#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2002, Guardian Digital, Inc.
 | $Id: index.cgi,v 1.1.2.2 2003/04/18 18:39:56 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  BEGIN { push @INC, '/usr/webtool/modules'; }

  # use perl;
  use WebTool;

  # Standard header.
  WebTool::Header('IPsec Management :: IPsec Management', '/Security/');

  my @foo = (
    foo('General Configuration',            'SecureVPN_genconfig.jpg'),
    foo('Security Gateways',                'SecureVPN_securitygateways.jpg'),
    foo('Local CA, Certificates, and Keys', 0),
    foo('Remote Certificates',              0),
    foo('Download Remote Configuration',    'SecureVPN_remoteconfig.jpg'),
    foo('Upload Remote Configuration',      0),
    foo('IPsec Control Panel',              0),
    foo('[ Stop IPsec ]',                   0),
    foo('[ Restart IPsec ]',                0),
  );

  my @bar = (
    'Edit options which affect all IPsec-related functions.',
    'Create and edit descriptions for local and remote security gateways.',
    foo('Manage local certification authority, issued certificates and shared keys.', 0),
    foo('Manage certificates for remote computers.', 0),
    'Download a remote profile suitable for uploading to another machine.',
    foo('Upload a remote profile from another machine.', 0),
    foo('View the status, establish, and terminate IPsec VPNs. ', 0),
  );

  # Print some HTML.
  print <<EOF;
<SCRIPT LANGUAGE="JavaScript">
  window.open('eval_info.cgi', 'ipsec_eval_info', 'toolbar=no,menubar=no, scrollbars=yes,resize=yes,width=550,height=500');
</SCRIPT>

<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      IPsec Management
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      IPsec is a security layer for IP.  In this module you can set up
      authentication methods, configure connection profiles, and view what
      connections are currently up/down.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD WIDTH="610">
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[0]</B>
          <BR>$bar[0]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[1]</B>
          <BR>$bar[1]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR> <TD> &nbsp; </TD> </TR>
      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[2]</B>
          <BR>$bar[2]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[3]</B>
          <BR>$bar[3]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR> <TD> &nbsp; </TD> </TR>
      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[4]</B>
          <BR>$bar[4]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[5]</B>
          <BR>$bar[5]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR> <TD> &nbsp; </TD> </TR>
      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[6]</B>
          <BR>$bar[6]
        </DIV></TD>
      </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR $tb> <TD> &nbsp; </TD> </TR>
      <TR> <TD> &nbsp; </TD> </TR>

      <TR>
        <TD>
          <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
          <TR>
            <TD WIDTH="50%" ALIGN="CENTER"><DIV CLASS="nbody"><B>
              $foo[7]
            </B></DIV></TD>

            <TD WIDTH="50%" ALIGN="CENTER"><DIV CLASS="nbody"><B>
              $foo[8]
            </B></DIV></TD>
          </TR>
          </TABLE>
        </TD>
      </TR>

      <TR> <TD> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>
EOF

  # Standard footer.
  WebTool::Footer();

################################################################################
sub foo($$) {
  my $msg          = shift;
  my $img          = shift;
  my $width        = 820;
  my $height       = 700;
  my ($eval_color) = ($tb =~ m/^BGCOLOR\=\"([^\"]+)\"$/);
  my $rv           = '';

  if ($img) {
    $rv  = "<A onClick=\"window.open('show_screenshot.cgi?file=$img', 'foo', "
         . "'toolbar=no,menubar=no,scrollbars=yes,resize=yes,width=$width,"
         . "height=$height');\" HREF=\"#\">";
  }

  $rv .= "<FONT COLOR=\"$eval_color\">$msg</FONT>";

  if ($img) { $rv .= "</A>"; }

  return $rv;
}
