#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: do_edit_cert.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "secure_email-lib.pl";
  &ReadParse();


  ###  Make sure we have the required inputs.
  if (!$in{'countryName'}) {
    &PrintError("Please enter a Country Name"); exit;
  }
  elsif (!$in{'stateOrProvinceName'}) {
    &PrintError("Please enter a State or Provence"); exit;
  }
  elsif (!$in{'localityName'}) {
    &PrintError("Please enter a City"); exit;
  }
  elsif (!$in{'organizationName'}) {
    &PrintError("Please enter an Organization"); exit;
  }
  elsif (!$in{'commonName'}) {
    &PrintError("Please enter an Authority Name"); exit;
  }
  elsif (!$in{'emailAddress'}) {
    &PrintError("Please enter an E-Mail Address"); exit;
  }


  ###  Define local variables.
  my ($TEMP_cert, $TEMP_key, $MODE);

  ###  Setup local variables.
  $TEMP_cert = &tempname();
  $TEMP_key  = &tempname();
  $MODE      = 0400;


  ###  Generate the new cert/key pair.
  open CA, "| $OPENSSL_BIN req -new -x509 -days 365 -nodes -out $TEMP_cert -keyout $TEMP_key -config /etc/ssl/openssl.cnf > /dev/null 2>&1";
    print CA "$in{'countryName'}\n";
    print CA "$in{'stateOrProvinceName'}\n";
    print CA "$in{'localityName'}\n";
    print CA "$in{'organizationName'}\n";
    print CA "$in{'organizationalUnitName'}\n";
    print CA "$in{'commonName'}\n";
    print CA "$in{'emailAddress'}\n";
  close CA;


  ###  Write our new cert/key into $in{'certfile'}.
  open NEWCERT, ">$in{'certfile'}";
    open KEY, $TEMP_key;  while (<KEY>) { print NEWCERT $_; } close KEY;
    open CRT, $TEMP_cert; while (<CRT>) { print NEWCERT $_; } close CRT;
  close NEWCERT;


  ###  Sanitize modes and unlink temp files.
  chmod $MODE, $in{'certfile'};
  chown 0, 0, $in{'certfile'};
  unlink $TEMP_cert, $TEMP_key;


  ###  Restart the daemon and go back to the index page.
  &DaemonCtl($in{'init'});
  &redirect("index.cgi");
