#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: edit_cert.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "secure_email-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($authority_HELP, $email_HELP, $department_HELP, $organization_HELP);
  my ($city_HELP, $state_HELP, $country_HELP);
  my ($header_STRING, $ditty_STRING, $CURRENT);
  my ($hidden_1_STRING, $hidden_2_STRING);

  ###  Setup local variables.
  $authority_HELP    = &hlink("Authority Name", "secure_email_authority");
  $email_HELP        = &hlink("E-Mail Address", "secure_email_email");
  $department_HELP   = &hlink("Department", "secure_email_department");
  $organization_HELP = &hlink("Organization", "secure_email_organization");
  $city_HELP         = &hlink("City", "secure_email_city");
  $state_HELP        = &hlink("State or Province", "secure_email_state");
  $country_HELP      = &hlink("Country", "secure_email_country");


  if ($in{'type'} eq "simap") {
    $hidden_1_STRING  =   $SIMAP_CERTFILE;
    $hidden_2_STRING  =   $SIMAP_INITSCRIPT;
    $header_STRING    =  "Edit SIMAP Certificate";
    $ditty_STRING     =  "Below you can edit the certificate for SIMAP.";
    %CURRENT          =   &GetCertificateInfo($SIMAP_CERTFILE);

  }
  elsif ($in{'type'} eq "spop3") {
    $hidden_1_STRING  =   $SPOP3_CERTFILE;
    $hidden_2_STRING  =   $SPOP3_INITSCRIPT;
    $header_STRING    =  "Edit SPOP3 Certificate";
    $ditty_STRING     =  "Below you can edit the certificate for SPOP3.";
    %CURRENT          =   &GetCertificateInfo($SPOP3_CERTFILE);
  }
  else { &redirect("index.cgi"); }


  ###  Print the usual header.
  &header("Secure Email Client Setup :: $header_STRING", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_cert.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="certfile" VALUE="$hidden_1_STRING">
  <INPUT TYPE="HIDDEN" NAME="init" VALUE="$hidden_2_STRING">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Secure Email Client Setup</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      $ditty_STRING
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
        <TR $tb>
          <TD COLSPAN="2"><B><DIV CLASS="thead">$header_STRING</DIV></TD></B>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$authority_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="commonName" SIZE="30" MAXLENGTH="64" VALUE="$CURRENT{'SUBJECT_CN'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$email_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="emailAddress" SIZE="30" MAXLENGTH="40" VALUE="$CURRENT{'SUBJECT_EMAIL'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$organization_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="organizationName" SIZE="30" VALUE="$CURRENT{'SUBJECT_O'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$department_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="organizationalUnitName" SIZE="30" VALUE="$CURRENT{'SUBJECT_OU'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$city_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="localityName" SIZE="30" VALUE="$CURRENT{'SUBJECT_L'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$state_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="stateOrProvinceName" SIZE="15" VALUE="$CURRENT{'SUBJECT_ST'}">
          </TD>
        </TR>

        <TR $cb>
          <TD><DIV CLASS="nbody"><B>$country_HELP</B></DIV></TD>
          <TD>
            <INPUT TYPE="TEXT" NAME="countryName" SIZE="3" VALUE="$CURRENT{'SUBJECT_C'}">
          </TD>
        </TR>

        <TR $cb>
          <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
            <INPUT TYPE="SUBMIT" NAME="update" VALUE="Update Certificate">
          </DIV></TD>
        </TR>

      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>

</CENTER><P>&nbsp;
EOF

  ###  Print the usual footer.
  &ryanFooter("index.cgi");
