#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: index.cgi,v 1.1.1.1.4.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "secure_email-lib.pl";


  ###  Define local variables.
  my ($certificate_HELP, $interface_HELP);
  my ($simap_interface_ICB, $spop3_interface_ICB);
  my (%simap_CERT, %spop3_CERT);

  ###  Setup local variables.
  $certificate_HELP     =  &hlink("Certificate", "secure_email_certificate");
  $interface_HELP       =  mkEvalPopup('Interface');
  $simap_interface_ICB  =  &interface_chooser_button("simap_interface", 0, 0);
  $spop3_interface_ICB  =  &interface_chooser_button("spop3_interface", 0, 1);
  %simap_CERT           =  &GetCertificateInfo($SIMAP_CERTFILE);
  %spop3_CERT           =  &GetCertificateInfo($SPOP3_CERTFILE);


  ###  Print the usual header.
  &header("Secure Email Client Setup", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Secure Email Client Setup</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can edit the certificate and the interface your SIMAP/SPOP
      daemons use.  The certificate is used for SSL (it provides identity
      verification).  The "Interface" is the IP address that the daemon should
      listen on.  Keep this field blank to have it listen on all interfaces.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
        <TR $tb>
          <TD COLSPAN="6"><B><DIV CLASS="thead">Secure IMAP</DIV></TD></B>
        </TR>

        <TR $cb>
          <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$certificate_HELP</B></DIV></TD>
          <TD VALIGN="TOP"><DIV CLASS="nbody"> <B>Subject</B></DIV></TD>
          <TD><DIV CLASS="nbody">
            $simap_CERT{'SUBJECT_CN'}
            <BR>$simap_CERT{'SUBJECT_O'}
            <BR>$simap_CERT{'SUBJECT_EMAIL'}
          </DIV></TD>

          <TD> &nbsp; </TD>
          <TD VALIGN="TOP"><DIV CLASS="nbody"> <B>Issuer</B></DIV></TD>
          <TD><DIV CLASS="nbody">
            $simap_CERT{'ISSUER_CN'}
            <BR>$simap_CERT{'ISSUER_O'}
            <BR>$simap_CERT{'ISSUER_EMAIL'}
          </DIV></TD>
        </TR>

        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <TR $cb>
          <TD> &nbsp; </TD>
          <TD><DIV CLASS="nbody"> <B>Fingerprint</B></DIV></TD>
          <TD COLSPAN="4"><DIV CLASS="nbody"> $simap_CERT{'FPRINT'} </DIV></TD>
        </TR>

        <TR $cb>
          <TD> &nbsp; </TD>
          <TD><DIV CLASS="nbody"> <B>Valid</B></DIV></TD>
          <TD COLSPAN="4"><DIV CLASS="nbody">
            $simap_CERT{'START'} until $simap_CERT{'END'}
          </DIV></TD>
        </TR>

        <TR $cb>
          <TD COLSPAN="6" ALIGN="RIGHT"> <DIV CLASS="nbody"><B>
            <A HREF="edit_cert.cgi?type=simap">[ Edit Certificate ]</A>
          </B></DIV></TD>
        </TR>

        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <TR $cb>
          <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$interface_HELP</B></DIV></TD>
          <TD COLSPAN="5">
            <FORM ACTION="save_interface.cgi" METHOD="POST">
              <INPUT TYPE="HIDDEN" NAME="init" VALUE="$SIMAP_INITSCRIPT">

              <INPUT TYPE="TEXT" NAME="simap_interface" VALUE="" SIZE="15" MAXLENGTH="15" DISABLED> $simap_interface_ICB &nbsp;&nbsp;
            </FORM>
          </TD>
        </TR>

        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>
        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <TR $tb>
          <TD COLSPAN="6"><B><DIV CLASS="thead">Secure POP3</DIV></TD></B>
        </TR>

        <TR $cb>
          <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$certificate_HELP</B></DIV></TD>
          <TD VALIGN="TOP"><DIV CLASS="nbody"> <B>Subject</B></DIV></TD>
          <TD><DIV CLASS="nbody">
            $spop3_CERT{'SUBJECT_CN'}
            <BR>$spop3_CERT{'SUBJECT_O'}
            <BR>$spop3_CERT{'SUBJECT_EMAIL'}
          </DIV></TD>

          <TD> &nbsp; </TD>
          <TD VALIGN="TOP"><DIV CLASS="nbody"> <B>Issuer</B></DIV></TD>
          <TD><DIV CLASS="nbody">
            $spop3_CERT{'ISSUER_CN'}
            <BR>$spop3_CERT{'ISSUER_O'}
            <BR>$spop3_CERT{'ISSUER_EMAIL'}
          </DIV></TD>
        </TR>

        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <TR $cb>
          <TD> &nbsp; </TD>
          <TD><DIV CLASS="nbody"> <B>Fingerprint</B></DIV></TD>
          <TD COLSPAN="4"><DIV CLASS="nbody"> $spop3_CERT{'FPRINT'} </DIV></TD>
        </TR>

        <TR $cb>
          <TD> &nbsp; </TD>
          <TD><DIV CLASS="nbody"> <B>Valid</B></DIV></TD>
          <TD COLSPAN="4"><DIV CLASS="nbody">
            $spop3_CERT{'START'} until $spop3_CERT{'END'}
          </DIV></TD>
        </TR>

        <TR $cb>
          <TD COLSPAN="6" ALIGN="RIGHT"> <DIV CLASS="nbody"><B>
            <A HREF="edit_cert.cgi?type=spop3">[ Edit Certificate ]</A>
          </B></DIV></TD>
        </TR>

        <TR $cb> <TD COLSPAN="6"> &nbsp; </TD> </TR>

        <TR $cb>
          <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$interface_HELP</B></DIV></TD>
          <TD COLSPAN="5">
            <FORM ACTION="save_interface.cgi" METHOD="POST">
              <INPUT TYPE="HIDDEN" NAME="init" VALUE="$SPOP3_INITSCRIPT">

              <INPUT TYPE="TEXT" NAME="spop3_interface" VALUE="" SIZE="15" MAXLENGTH="15" DISABLED> $spop3_interface_ICB &nbsp;&nbsp;
            </FORM>
          </TD>
        </TR>

      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>&nbsp;
EOF

  ###  Print the usual footer.
  &ryanFooter("/Security/");
