#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: secure_email-lib.pl,v 1.1.1.1.4.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  require "../Security.pl";

  ### ##########################################################################
  ### Global Variables
  ### ##########################################################################
  $OPENSSL_BIN       =  '/usr/bin/openssl';
  $SIMAP_INITSCRIPT  =  '/etc/init.d/stunnel-imap';
  $SPOP3_INITSCRIPT  =  '/etc/init.d/stunnel-pop3';
  $SIMAP_CERTFILE    =  '/etc/ssl/certs/imapd-server.pem';
  $SPOP3_CERTFILE    =  '/etc/ssl/certs/pop3d-server.pem';



  ### ##########################################################################
  sub GetCertificateInfo() {
    my (%rv, $tmp);

    undef $tmp; $tmp       =  `openssl x509 -fingerprint -in $_[0]`;
    ($rv{'FPRINT'})        =  ($tmp =~ m/Fingerprint\=(.*)/);

    undef $tmp; $tmp       =  `openssl x509 -dates -in $_[0]`;
    ($rv{'START'})         =  ($tmp =~ m/notBefore\=(.*)/);
    ($rv{'END'})           =  ($tmp =~ m/notAfter\=(.*)/);

    undef $tmp; $tmp       =  `openssl x509 -issuer -in $_[0]`;
    ($rv{'ISSUER_C'})      =  ($tmp =~ m/\/C\=([^\/]+)\//);
    ($rv{'ISSUER_ST'})     =  ($tmp =~ m/\/ST\=([^\/]+)\//);
    ($rv{'ISSUER_L'})      =  ($tmp =~ m/\/L\=([^\/]+)\//);
    ($rv{'ISSUER_O'})      =  ($tmp =~ m/\/O\=([^\/]+)\//);
    ($rv{'ISSUER_OU'})     =  ($tmp =~ m/\/OU\=([^\/]+)\//);
    ($rv{'ISSUER_CN'})     =  ($tmp =~ m/\/CN\=([^\/]+)\//);
    ($rv{'ISSUER_EMAIL'})  =  ($tmp =~ m/\/Email\=([^\-]+)/);

    undef $tmp; $tmp       =  `openssl x509 -subject -in $_[0]`;
    ($rv{'SUBJECT_C'})     =  ($tmp =~ m/\/C\=([^\/]+)\//);
    ($rv{'SUBJECT_ST'})    =  ($tmp =~ m/\/ST\=([^\/]+)\//);
    ($rv{'SUBJECT_L'})     =  ($tmp =~ m/\/L\=([^\/]+)\//);
    ($rv{'SUBJECT_O'})     =  ($tmp =~ m/\/O\=([^\/]+)\//);
    ($rv{'SUBJECT_OU'})    =  ($tmp =~ m/\/OU\=([^\/]+)\//);
    ($rv{'SUBJECT_CN'})    =  ($tmp =~ m/\/CN\=([^\/]+)\//);
    ($rv{'SUBJECT_EMAIL'}) =  ($tmp =~ m/\/Email\=([^\-]+)/);

    return %rv;
  }


  ### ##########################################################################
  sub DaemonCtl() {
    my ($rc); $rc = "";

    my (%E); %E = %ENV; %ENV = ();
      $rc = system "$_[0] restart > /dev/null 2>&1";
    %ENV = %E;

    return $rc;
  }


  ### ##########################################################################
  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>
ErrorEOF
  }


  ### ##########################################################################
  1;
