#!/usr/bin/perl


  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';
  &ReadParse();


  $editor   = "/usr/webtool/Security/tripwire/webtool_editor.pl";

  ### Setup our local variables.
  $lp       = $in{'lp'};
  $report   = $in{'report'};
  $tempfile = $in{'tempfile'};

  ### Error checking.
  if (!$lp) { &PrintError("Please enter a 'Local Passphrase'.", -1); exit; }


  $lref = &read_file_lines($tempfile);

  foreach (@$lref) {

    if ($_ =~ m/^\[.*\"(.*)\"$/) {
      if ($in{"$1_u"}) { $_ = "\[x\] \"$1\""; }
      else { $_ = "\[ \] \"$1\""; }
    }
    #else { print TMP2 "$_"; }

  }

  &flush_file_lines($tempfile);

  ### Run tripwire.
  $out = `/usr/sbin/tripwire --update -r $report -P "$lp" -V "$editor $tempfile" -Z high 2>&1`;


  ### Our local passphrase was incorrect, so notify the user.
  if ($out =~ m/Incorrect\ local\ passphrase/) {
    &PrintError("You entered an invalid 'Local Passphrase'", -1);
  }

  ### Print a success message and go back to the index page.
  elsif ($out =~ m/Wrote\ database\ file/) {
    &PrintError("The database was successfully updated", -2);
  }
  else {
    &PrintError("The filesystem has changed since your last report, so the database was not updated", -2);
  }


