#!/usr/bin/perl


  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';

  ### Print the header and a horizonal rule.
  &header("Tripwire Maintenance", "");


  ###
  ### Make sure tripwire is set up properly.
  ###
  my $HOSTNAME = `cat /proc/sys/kernel/hostname`;
  chomp $HOSTNAME;

  if ( (! -f "/etc/tripwire/$HOSTNAME-local.key") ||
       (! -f "/etc/tripwire/site.key") ||
       (! -f "/etc/tripwire/tw.cfg") ||
       (! -f "/etc/tripwire/tw.pol") ||
       (! -f "/var/lib/tripwire/$HOSTNAME.twd")) {

    print <<NOCONFIG;

<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
<TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Tripwire Maintenance</B></TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
  Tripwire must be configured before you can use this module.  Unfortunately,
  this cannot be done through the WebTool at this time so it must be done from
  a shell.  To configure Tripwire, run these commands as root:

<P><PRE>
  ### Disable LIDS if necessary
  [root\@machine:/root:]# lidsadm -S -- -LIDS_GLOBAL

  ###  Set up passphrases
  [root\@machine:/root:]# /etc/tripwire/twinstall.sh

  ###  Initalize the database
  [root\@machine:/root:]# tripwire --init
</PRE>

  <P>The <I>twinstall.sh</I> script will prompt you to create a <B>site keyfile
  passrphase</B> and a <B>local keyfile passphrase</B>.  Once these passwords
  are created you will be prompted for them a few times.  The <I>tripwire
  --init</I> command will initalize the Tripwire database.

  <P>Please come back to this page when you have performed these steps.
</TD></TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE></CENTER><P>

NOCONFIG

    &ryanFooter("/Security/");
  }
  else {

  print <<TABLE01;
<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
<TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Tripwire Maintenance</B></TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
Below you can view reports and update your tripwire policy files.
</TD></TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="edit_email.cgi">Define Administrator</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Define where you want the daily report e-mailed to.
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="edit_schedule.cgi">Schedule Tripwire</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Define when you want tripwire to generate reports
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="generate_report.cgi">Generate Report</A>
    </B></DIV>
  </TD>
  <TD> <DIV CLASS=nbody>
         Generate a new report with the current state of the system.
  </DIV> </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="list_reports.cgi">View Reports</A>
    </B></DIV>
  </TD>
  <TD> <DIV CLASS=nbody> View and delete reports.  </DIV> </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="update_database.cgi">Update Database</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Update the local database as per the most recent report.
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE></CENTER><P>
TABLE01

    &ryanFooter("/Security/");
  }

