#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';

  ### Print the header and a horizonal rule.
  &header("Tripwire Maintenance :: Select Report", "");


  my @months = &get_monthnames();

print <<TABLE01;
<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=3>
      <DIV CLASS=ttitle><B>View a Tripwire Report</B></DIV>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=3>
      <DIV CLASS=nbody>
        Below you can look at the contents of a tripwire report and optionally
        update the database.
      </DIV>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

  <TR $tb>
    <TD>
      <DIV CLASS=thead><B>Date</B></DIV>
    </TD>
    <TD>
      <DIV CLASS=thead><B>Time</B></DIV>
    </TD>
    <TD>
      <DIV CLASS=thead><B>Filename</B></DIV>
    </TD>
  </TR>
TABLE01

  my @files = glob "/var/lib/tripwire/report/*.twr";

  if (@files >= 1) {
    foreach (@files) {

      ### Razzle-dazzle some string manipulation.
      my ($filename)    = ($_ =~ m/\/var\/lib\/tripwire\/report\/(.*)$/);
      my ($date, $time) = ($_ =~ m/\-([0-9]+)\-([0-9]+)\.twr$/);
      my ($y, $m, $d)   = ($date =~ m/^([0-9]{4})([0-9]{2})([0-9]{2})$/);
      my ($h, $i, $s)   = ($time =~ m/^([0-9]{2})([0-9]{2})([0-9]{2})$/);

      ### Print out our table.
      print "  <TR $cb>\n";
      print "    <TD><DIV CLASS=nbody>$months[$m] $d, $y</DIV></TD>\n";
      print "    <TD><DIV CLASS=nbody>$h:$i</DIV></TD>\n";
      print "    <TD><DIV CLASS=nbody><A HREF=view_report.cgi?file=$_>",
            "$filename</A></TD>\n";
      print "</TR>\n\n";
    }
  }
  else {
    print "  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>\n\n";
    print "  <TR $cb>\n";
    print "    <TD COLSPAN=3><DIV CLASS=nbody><B>\n";
    print "      There are currently no reports.\n";
    print "    </B></DIV></TD>\n";
    print "  </TR>\n\n";
  }


print <<TABLE02;

  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>
</TABLE></CENTER><P>
TABLE02

  &ryanFooter("index.cgi");


