#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';
  &ReadParse();


  ### Extract input variables into local variables.
  my $new_email  = $in{'email'};
  my $lp         = $in{'lp'};
  my $sp         = $in{'sp'};


  ### Verify inputs.
  if (!$new_email) {
     &PrintError("Please enter an 'E-Mail Address'.", -1); exit;
  }
  elsif (!$lp) { &PrintError("Please enter a 'Local Passphrase'.", -1); exit; }
  elsif (!$sp) { &PrintError("Please enter a 'Site Passphrase'.", -1); exit; }


  ### Replace the ADMINMAIL line in the policy file.
  $lref = &read_file_lines("/etc/tripwire/twpol.txt");
    for (my $i = 0; $i < @$lref; $i++) {
      if (@$lref[$i] =~ m/^ADMINMAIL\=\"(.*)\"\ \;$/) {
        @$lref[$i] = "ADMINMAIL=\"$new_email\" ;";
        $old_email = $1;
      }
    }
  &flush_file_lines();


  ### Build up the command string.
  $cmd  = "/usr/sbin/tripwire --update-policy --cfgfile /etc/tripwire/tw.cfg ";
  $cmd .= "--polfile /etc/tripwire/tw.pol --secure-mode low ";
  $cmd .= "-P \"$lp\" -Q \"$sp\" /etc/tripwire/twpol.txt";

  ### Update our policy file.
  $out = `$cmd`;


  ### Our local passphrase was incorrect, so notify the user and set back email.
  if ($out =~ m/Incorrect\ local\ passphrase/) {

    ### Replace the ADMINMAIL line back to what it was.
    $lref = &read_file_lines("/etc/tripwire/twpol.txt");
      for (my $i = 0; $i < @$lref; $i++) {
        if (@$lref[$i] =~ m/^ADMINMAIL\s+\=\ (.*)\ \;$/) {
          @$lref[$i] = "ADMINMAIL        = $old_email ;";
        }
      }
    &flush_file_lines();

    &PrintError("You entered an invalid 'Local Passphrase'.", -2);
    exit;
  }

  ### Our site passphrase was incorrect, so notify the user and set back email.
  elsif ($out =~ m/Incorrect\ site\ passphrase/) {

    ### Replace the ADMINMAIL line back to what it was.
    $lref = &read_file_lines("/etc/tripwire/twpol.txt");
      for (my $i = 0; $i < @$lref; $i++) {
        if (@$lref[$i] =~ m/^ADMINMAIL\s+\=\ (.*)\ \;$/) {
          @$lref[$i] = "ADMINMAIL        = $old_email ;";
        }
      }
    &flush_file_lines();

    &PrintError("You entered an invalid 'Site Passphrase'.", -2);
    exit;
  }

  ### All went well, so let's go back.
  else {
    &PrintError("Your policy file was updated successfully", -2);
  }
  
