### ############################################################################
### Ryan W. Maple <ryan@guardiandigital.com>
### Guardian Digital, Inc.
### ############################################################################

  ### Be mean
  use strict;

  ### Include the general subroutines from web-lib.pl and do init_config().
  do '/usr/webtool/web-lib.pl';
  &init_config();


  ### ##########################################################################
  ### read_report()
  ### ##########################################################################
  ### Given a report name, do two things:
  ###   1) Read it into a tempfile for later use with '--update'
  ###   2) Return it as an array so the calling script can display it.
  ### ##########################################################################

  sub read_report() {
    my ($twr, $tempfile) = @_;
    my @LINES;

    open TMP, ">$tempfile";

    open TRIPWIRE, "tripwire --update --twrfile $twr -P this -V cat |";
      while (<TRIPWIRE>) {
        print TMP $_;

        chomp $_;

        if ($_ =~ m/^\*\*\*\ End\ of\ report\ \*\*\*$/) {
          close TMP;
          close TRIPWIRE; return @LINES;
        }
        else { push @LINES, $_; }
      }
  }

  ### ##########################################################################
  ### get_monthnames()
  ### ##########################################################################
  ### A very simple routine to return an array of month names.
  ### ##########################################################################
  
  sub get_monthnames() {
    my (@months);

    @months = ( 'zero', 'January', 'February', 'March', 'April', 'May', 'June',
                'July', 'August', 'September', 'October', 'November',
                'December');

    return @months;
  }

  ### ##########################################################################
  ### get_admin()
  ### ##########################################################################
  ### Get the current value of ADMINMAIL in our text policy file.
  ### ##########################################################################

  sub get_admin() {
    my $polfile = "/etc/tripwire/twpol.txt";
    my $admin;

    open POLICY, $polfile;
      while (<POLICY>) {
        chomp $_;
        if ($_ =~ m/^ADMINMAIL\=\"(.*)\" \;$/) { $admin = $1; }
      }
    close POLICY;

    return $admin
  }

  ### ##########################################################################
  ### PrintError()
  ### ##########################################################################
  ### Used to pop up a JavaScript with a $message then return user to 
  ### previous page.
  ### ##########################################################################

  sub PrintError {
    my ($message, $level) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go($level);
  </SCRIPT>
</HEAD>
</HTML>  
ErrorEOF
  }


  ### ##########################################################################
  ### Return one like a good little library *pat on head*.
  ### ##########################################################################
  1;
