#!/usr/bin/perl


  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';
  &ReadParse();

  ### Find the most recent file.
  my %max = { 'mtime' => 0, 'file'  => '' }; 
  my @reports = glob "/var/lib/tripwire/report/*.twr";
  foreach (@reports) {
    my @this = stat $_;
    if ($this[9] > $max) { $max{'mtime'} = $this[9]; $max{'file'} = $_; }

  }

  ### Print the header and a horizonal rule.
  &header("Tripwire Maintenance :: Update Database", "");

  my $file = $max{'file'};
  my $tempfile = &tempname();

print <<TABLE01;
<FORM ACTION="do_update_database.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="report" VALUE="$file">
<INPUT TYPE="HIDDEN" NAME="tempfile" VALUE="$tempfile">
<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
<TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Tripwire Maintenance</B></TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
Below you can view reports and update your tripwire policy files.
</TD></TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD COLSPAN=2>
  <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>

TABLE01

  @LINE = &read_report($file, $tempfile);

  foreach (@LINE) {

    ### We are in the master section, so set our flag.
    if ($_ =~ m/^Object\ Summary\:/)   { $IN_SUMMARY = 1; }
    elsif ($_ =~ m/^Object\ Detail\:/) { $IN_SUMMARY = 0; }

    ### We have encountered a new rule, so print a new header.
    if ($IN_SUMMARY && ($_ =~ m/^Rule\ Name\:\ (.*)$/)) {
      print "<TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>\n\n";
      print "<TR $tb><TD COLSPAN=3><DIV CLASS=thead><B>$1</TD></TR>\n\n";
    }

    if ($_ =~ m/^Added\:$/)    { $IN_ADD = 1; }
    elsif ($IN_ADD && ($_ eq "")) { $IN_ADD = 0; }

    elsif ($_ =~ m/^Removed\:$/)  { $IN_DEL = 1; }
    elsif ($IN_DEL && ($_ eq "")) { $IN_DEL = 0; }

    ### We have a [x] line...
    if ($_ =~ m/^\[x\]\ \"(.*)\"$/) {
      print "<TR $cb>\n";

      if ($IN_ADD) {
        print "  <TD><DIV CLASS=nbody><B>Added</B></DIV></TD>\n";
      }
      elsif ($IN_DEL) {
        print "  <TD><DIV CLASS=nbody><B>Removed</B></DIV></TD>\n";
      }
      else {
        print "  <TD><DIV CLASS=nbody><B>Modified</B></DIV></TD>\n";
      }

      print "  <TD>\n";
      print "    <INPUT TYPE=\"HIDDEN\" NAME=\"$1\" VALUE=\"FILENAME\">\n";
      print "    <INPUT TYPE=\"CHECKBOX\" NAME=\"$1_u\" CHECKED>\n";
      print "  </TD>\n";
      print "  <TD><DIV CLASS=nbody>$1</DIV></TD>\n";
      print "</TR>\n";
    }
  }

print <<TABLE02;
  </TABLE>
  </TD>
</TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH=75%>&nbsp;</TD>
    <TD $tb><DIV CLASS=thead><B>Local Passphrase</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD WIDTH=75%>&nbsp;</TD>
    <TD><DIV CLASS=tbody><INPUT TYPE="PASSWORD" NAME="lp" SIZE="30"></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD COLSPAN=2 ALIGN="RIGHT">
      <DIV CLASS=nbody>
        <INPUT TYPE="SUBMIT" VALUE="Update Database">
      </DIV>
    </TD>
  </TR>

</TABLE></CENTER></FORM><P>
TABLE02

  &ryanFooter("index.cgi");


