#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: index.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "servicemon-lib.pl";

  ###  Print the usual header.
  &header("Services Monitor", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle"> Services Monitor </DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can enable/disable services.  To change the status of a service
      (to enable a disabled service or vice versa), click on the status link.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="0">
      <TR $tb>
        <TD WIDTH="40%"><DIV CLASS="thead"><B>Service Name</B></DIV></TD>
        <TD WIDTH="20%"><DIV CLASS="thead"><B>Current Status</B></DIV></TD>
        <TD WIDTH="20%"><DIV CLASS="thead"><B>Enable at Boot?</B></DIV></TD>
        <TD WIDTH="20%"> &nbsp; </TD>
      </TR>

EOF


  ###  Iterate through the services, offering links to enable/disable.
  foreach my $s (sort portsort @SERVICES) {
    my ($CURRENT, $BOOT);

    ###  Don't try to configure services we don't have installed.
    next if (! -f "/etc/init.d/$s->{'init'}");


    ###  Build our "Current Status" string.
    if (&isServiceActive($s->{'port'})) {
      $CURRENT = "<FONT COLOR=\"GREEN\">[&nbsp;Enabled&nbsp;]</FONT>";
      $BOOT    = "[&nbsp;Enabled&nbsp;]";
    }
    else {
      $CURRENT = "<FONT COLOR=\"RED\">[&nbsp;Disabled&nbsp;]</FONT>";
      $BOOT    = "[&nbsp;Disabled&nbsp;]";
    }

    ###  Build our "At Boot" string.  Special for xinetd services.
    if ($s->{'init'} eq "xinetd") {
      $BOOT  = $BOOT;
    }
    elsif (&isServiceActiveAtBoot($s->{'init'})) {
      $BOOT  = "<A HREF=\"do_toggle.cgi?f=boot&init=$s->{'init'}&port=";
      $BOOT .= "$s->{'port'}\"><FONT COLOR=\"GREEN\">[&nbsp;";
      $BOOT .= "Enabled&nbsp;]</FONT></A>";
    }
    else {
      $BOOT  = "<A HREF=\"do_toggle.cgi?f=boot&init=$s->{'init'}&port=";
      $BOOT .= "$s->{'port'}\"><FONT COLOR=\"RED\">[&nbsp;";
      $BOOT .= "Disabled&nbsp;]</FONT></A>";
    }

    ###  Now print the HTML.
    print <<EOF;
      <TR>
        <TD><DIV CLASS="nbody"><B>$s->{'name'}</B></DIV></TD>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="do_toggle.cgi?f=current&init=$s->{'init'}&port=$s->{'port'}">$CURRENT</A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody"><B>
          $BOOT
        </B></DIV></TD>
        <TD> &nbsp; </TD>
      </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;
    </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <FORM ACTION="do_systemctl.cgi" METHOD="POST">
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Reboot or Shutdown System</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          Below you can reboot or halt your system.  You must check the
          confirmation box before any action will be taken.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="30%"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" NAME="reboot" VALUE="Reboot System">
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          <INPUT TYPE="CHECKBOX" NAME="rebootconfirm">&nbsp;&nbsp;I'm sure I want to reboot the system
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="30%"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" NAME="shutdown" VALUE="Shutdown System">
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          <INPUT TYPE="CHECKBOX" NAME="shutdownconfirm">&nbsp;&nbsp;I'm sure I want shutdown the system
        </DIV></TD>
      </TR>

      </TABLE>
      </FORM>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("/StatusMonitor/");

