#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2002-2003 Guardian Digital, Inc., All Rights Reversed
 | $Id: index.cgi,v 1.1.2.3 2003/04/18 18:39:56 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  BEGIN { push @INC, '/usr/webtool/modules'; }

  # use perl;
  use WebTool;
  sub foo($$);

  # Standard header.
  WebTool::Header('Guardian Digital Secure Mail Suite', '/SystemManager');

  my @foo = (
    foo('Server Configuration',  'SecureMail_genconfig.jpg'),
    foo('Graphs and Reports',    'SecureMail_graphs1.jpg'),
    foo('Queue Maintenance',     'SecureMail_queuemaint.jpg'),
    foo('LDAP Configuration',    'SecureMail_ldapconfig.jpg'),
    foo('LDAP Aliases',          0),
    foo('LDAP Virtual Domains',  0),
    foo('Aliases and Routing',   0),
    foo('Virtual Domains',       'SecureMail_virtual.jpg'),
    foo('Access Controls',       0),
    foo('Header Checking',       'SecureMail_headercheck.jpg'),
    foo('Body Checking',         0),
    foo('Disclaimer Footer',     'SecureMail_footer.jpg'),
    foo('TLS Server Setup',      'SecureMail_tlsserver.jpg'),
    foo('TLS Client Setup',      0),
    foo('Spam Configuration',    'SecureMail_spamconfig.jpg'),
    foo('Virus Configuration',   'SecureMail_virusconfig.jpg'),
    foo('Spam/Virus Quarantine', 'SecureMail_spamquarantine.jpg'),
  );

  my @bar = (
    'Setup basic mail server configuration.',
    'View access statistics, graphs, and usage reports.',
    'Monitor and maintain the mail queue.',
    'Enable and setup communication with an LDAP server.',
    foo('Manage aliases stored in the LDAP database.', 0),
    foo('Manage virtual domains stored in the LDAP database.', 0),
    'Configure local mail aliases and mail routes.',
    foo('Set up virtual domain mail mappings.', 0),
    'Edit SMTP Client and Sender Address access controls.',
    foo('Block/log specific SMTP headers and MIME patterns.', 0),
    'Block/log messages based upon message content.',
    foo('Enable and edit a footer to be appended to all messages.', 0),
    'Manage your local CA and issue TLS User Certificates.',
    foo('Configure this machine to act as a TLS client.', 0),
    'Configure the spam scanning subsystem.',
    'Configure the virus scanning subsystem.',
    'View messages quarantined for containing spam or viruses.',
  );

  # Display page.
  print <<EOF;
<SCRIPT LANGUAGE="JavaScript">
  window.open('eval_info.cgi', 'mss_eval_info', 'toolbar=no,menubar=no, scrollbars=yes,resize=yes,width=550,height=500');
</SCRIPT>

<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      Guardian Digital Mail Server Suite
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Welcome to the <B>Guardian Digital Mail Server Suite</B>.  Please use
      the links below to navigate through this module.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
<!-- BEGIN General Configuration and Monitoring -->
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead">
          <B>General Configuration and Monitoring</B>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[0]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[0]
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[1]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[1]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[2]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[2]
        </DIV></TD>
      <TR>


      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead">
          <B>LDAP Configuration</B>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[3]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[3]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[4]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[4]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[5]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[5]
        </DIV></TD>
      <TR>

<!-- BEGIN Basic Configuration -->
      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead">
          <B>Basic Configuration</B>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[6]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[6]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[7]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[7]
        </DIV></TD>
      <TR>


<!-- BEGIN Mail Server Policy Management -->
      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead">
          <B>Mail Server Policy Management</B>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[8]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[8]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[9]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[9]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[10]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[10]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[11]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[11]
        </DIV></TD>
      <TR>

      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[12]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[12]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[13]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[13]
        </DIV></TD>
      <TR>


<!-- BEGIN CAPE Center -->
      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead">
          <B>CAPE Center</B>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[14]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[14]
        </DIV></TD>
      <TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[15]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[15]
        </DIV></TD>
      <TR>

      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody">
          <B>$foo[16]</B>
        </DIV></TD>
        <TD><DIV CLASS="nbody">
          $bar[16]
        </DIV></TD>
      <TR>

      <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>
EOF

  # Standard footer.
  WebTool::Footer();

################################################################################
sub foo($$) {
  my $msg          = shift;
  my $img          = shift;
  my $width        = 820;
  my $height       = 700;
  my ($eval_color) = ($tb =~ m/^BGCOLOR\=\"([^\"]+)\"$/); 
  my $rv           = '';

  if ($img) {
    $rv  = "<A onClick=\"window.open('show_screenshot.cgi?file=$img', 'foo', "
         . "'toolbar=no,menubar=no,scrollbars=yes,resize=yes,width=$width,"
         . "height=$height');\" HREF=\"#\">";
  }

  $rv .= "<FONT COLOR=\"$eval_color\">$msg</FONT>";

  if ($img) { $rv .= "</A>"; }

  return $rv;
}
