#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: do_edit_resolv.cgi,v 1.2 2003/02/25 15:52:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  use File::Copy qw(copy);
  require "network-lib.pl";
  &ReadParse();


  ###  Clobber the existing resolv.conf with ours.
  open RESOLV, ">$RESOLV_FILE";

    ###  Print the search domains.
    print RESOLV "search $in{'search'}\n";

    ###  Print the (possibly updated) DNS servers.
    foreach my $k (sort keys %in) {
      if (($k =~ m/^dnsserver\_/) && $in{$k} && (&isIP($in{$k}))) {
        print RESOLV "nameserver $in{$k}\n";
      }
    }

    ###  Finally, print the "new" DNS server if we have a valid one.
    if ($in{'new_dnsserver'} && (&isIP($in{'new_dnsserver'}))) {
      print RESOLV "nameserver $in{'new_dnsserver'}\n";
    }

  ###  Close resolv.conf up.
  close RESOLV;


  ###  This is easy; save the hostname.
  &SaveHostname($in{'hostname'});


  #
  # Now we need to update the resolv.conf in the Postfix chroot:
  #  a) If /etc/resolv.conf is a normal file then just copy it.
  #  b) If /etc/resolv.conf is a symlink then dereference it and copy it.
  #
  my $target = (-l $RESOLV_FILE) ? readlink $RESOLV_FILE : $RESOLV_FILE;
  copy($target, $POSTFIX_RESOLV);

  ###  Go back to the index page.
  &redirect("index.cgi");
