#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: do_edit_virtual_interface.cgi,v 1.1.1.1.4.2 2003/04/18 12:37:08 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";
  &ReadParse();


  ###  Only check the input values if we are creating or saving.
  if ($in{'create'} || $in{'save'}) {
    if (! $in{'address'}) {
      &PrintError("Please enter an 'IP Address'"); exit;
    }
    elsif (! $in{'netmask'}) {
      &PrintError("Please enter a 'Netmask'"); exit;
    }
    elsif (! &isIP($in{'address'})) {
      &PrintError("You entered an invalid 'IP Address'"); exit;
    }
    elsif (! &isIP($in{'netmask'})) {
      &PrintError("You entered an invalid 'Netmask'"); exit;
    }
    elsif (! $in{'real_interface'}) {
      &PrintError("Please select an interfac to 'Attach To'"); exit;
    }
  }


  ###  We want to define a new interface.
  if ($in{'create'}) {
    my ($lref, $network, $broadcast, $vin);

    my $cnt = 0;
    foreach my $i (&ReadInterfaces) { $cnt++ if ($i->{'virtual'}); }
    if ($cnt >= 10) {
      my $msg = "You have reached the limit of 10 virtual interfaces\\n"
              . "available in the Community Edition of EnGarde Secure Linux.";
      &PrintError($msg);
      exit;
    }

    ###  Setup our variables.
    $vin         =  GetNextVirtualInterfaceNumber($in{'real_interface'});
    $network     =  &GetNetwork($in{'address'}, $in{'netmask'});
    $broadcast   =  &GetBroadcast($in{'address'}, $in{'netmask'});
    $lref        =  &read_file_lines($INTERFACES_FILE);

      ###  Push our new entry into the file.
      push @$lref, "iface $in{'real_interface'}:$vin inet static";
      push @$lref, "   address $in{'address'}";
      push @$lref, "   netmask $in{'netmask'}";
      push @$lref, "   network $network";
      push @$lref, "   broadcast $broadcast\n";

    ###  Finally, write the file to disk and bring the interface up.
    &flush_file_lines();
    &IfUp("$in{'real_interface'}:$vin");
  }

  ###  We want to update or remove the interface.
  elsif ($in{'save'} || $in{'delete'}) {
    my ($CURRENT, $lref, $OFFSET, $LENGTH);

    ###  Get $CURRENT.
    foreach my $i (&ReadInterfaces) {
      if ($i->{'interface'} eq $in{'iface'}) { $CURRENT = $i; }
    }

    ###  Setup local variables.
    $lref   =  &read_file_lines($INTERFACES_FILE);
    $OFFSET = $CURRENT->{'START'};
    $LENGTH = $CURRENT->{'END'} - $CURRENT->{'START'} + 1;


    ###  Case 1:  We want to delete this interface, so just splice it out.
    if ($in{'delete'}) {
      splice @$lref, $OFFSET, $LENGTH;
      &IfDown($CURRENT->{'interface'});
      &flush_file_lines();
    }

    ###  Case 2:  We want to save this interface, so build up $new and replace.
    else {
      my (@new, $network, $broadcast);

      ###  Recalculate network and broadcast numbers.
      $network     =  &GetNetwork($in{'address'}, $in{'netmask'});
      $broadcast   =  &GetBroadcast($in{'address'}, $in{'netmask'});

      ###  Build up our new interface block.
      push @new, "iface $CURRENT->{'interface'} inet static";
      push @new, "   address $in{'address'}";
      push @new, "   netmask $in{'netmask'}";
      push @new, "   network $network";
      push @new, "   broadcast $broadcast\n";

      ###  Splice out the old and splice in the new.
      splice @$lref, $OFFSET, $LENGTH, @new;
      &flush_file_lines();

      ###  Drop the interface then bring it right back up again.
      &IfDown($CURRENT->{'interface'});
      sleep 1;
      &IfUp($CURRENT->{'interface'});
    }
  }


  ###  Go back to the index page.
  &redirect("index.cgi");
