#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: edit_physical_interface.cgi,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($CURRENT, %PPPOE, $iface_HEADER, $iface_TEXT, $iface_SUBMIT);
  my ($address_HELP, $netmask_HELP, $clobber_resolv_HELP);
  my ($pump_CLOBBERVAL_y, $pump_CLOBBERVAL_n);
  my ($pppoe_CLOBBERVAL_y, $pppoe_CLOBBERVAL_n);

  ###  Setup local variables.
  %PPPOE                   =  &GetPPPoEConfig();
  $address_HELP            =  &hlink("IP Address", "network_address");
  $netmask_HELP            =  &hlink("Netmask", "network_netmask");
  $clobber_resolv_HELP     =  &hlink("Overwrite&nbsp;DNS&nbsp;Configuration", "network_clobber_resolv");
  $pppoe_username_HELP     =  &hlink("Username", "network_pppoe_username");
  $pppoe_password_HELP     =  &hlink("Password", "network_pppoe_password");
  $pppoe_acname_HELP       =  &hlink("AC Name", "network_pppoe_acname");
  $pppoe_servicename_HELP  =  &hlink("Service Name", "network_pppoe_servicename");

  ###  Zero-out some strings.
  $dhcp_CHECKVAL        =  $pppoe_CHECKVAL      =  $static_CHECKVAL = "";
  $pump_CLOBBERVAL_y    =  $pump_CLOBBERVAL_n   =  "";
  $pppoe_CLOBBERVAL_y   =  $pppoe_CLOBBERVAL_n  =  "";

  ###  Setup some specific variables for creation/edition.
  if ($in{'new'}) {
    $CURRENT            =  undef;
    $static_CHECKVAL    =  "CHECKED";
    $iface_HEADER       =  "Define New";
    $iface_TEXT         =  "Below you can define a new physical interface.";
    $iface_SUBMIT       =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="create" VALUE="Define Interface">
        </DIV></TD>
      </TR>
      </TABLE>
EOF
  }
  else {
    $iface_HEADER  =  "Edit";
    $iface_TEXT    =  "Below you can edit or delete an existing physical interface.";
    $iface_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="LEFT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="delete" VALUE="Delete Interface">
        </DIV></TD>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="save" VALUE="Save Interface">
        </DIV></TD>
      </TR>
      </TABLE>
EOF

    foreach my $i (&ReadInterfaces) {
      if ($i->{'interface'} eq $in{'iface'}) { $CURRENT = $i; }
    }

    if ($CURRENT->{'type'} eq "dhcp")     { $dhcp_CHECKVAL   = "CHECKED"; }
    elsif ($CURRENT->{'type'} eq "pppoe") { $pppoe_CHECKVAL  = "CHECKED"; }
    else                                  { $static_CHECKVAL = "CHECKED"; }

  }

  ###  Determine if pump is clobbering /etc/resolv.conf.
  if (&IsDHCPClobberingResolv()) { 
    $pump_CLOBBERVAL_y  =  "CHECKED"; $pump_CLOBBERVAL_n  =  "";
  } else {
    $pump_CLOBBERVAL_y  =  ""; $pump_CLOBBERVAL_n  =  "CHECKED";
  }

  ###  Determine if pump is clobbering /etc/resolv.conf.
  if (&IsPPPoEClobberingResolv()) { 
    $pppoe_CLOBBERVAL_y  =  "CHECKED"; $pppoe_CLOBBERVAL_n  =  "";
  } else {
    $pppoe_CLOBBERVAL_y  =  ""; $pppoe_CLOBBERVAL_n  =  "CHECKED";
  }


  ###  Print the usual header.
  &header("Network Configuration :: $iface_HEADER Pysical Interface", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_physical_interface.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="iface" VALUE="$CURRENT->{'interface'}">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Interface Setup</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      $iface_TEXT
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="4"><DIV CLASS="thead"><B>Static Interface</B></DIV></TD>
      </TR>
      <TR $cb>
        <TD COLSPAN="4"><DIV CLASS="nbody">
          A static interface consists of pre-defined network settings that are
          restored upon each reboot.  If you are in a small office or on a LAN,
          this is probably the option for you.  Simply select the "Use a static
          address" checkbox, enter in your IP address and netmask, and save your
          settings.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4"><DIV CLASS="nbody">
          <INPUT TYPE="RADIO" NAME="type" VALUE="static" $static_CHECKVAL> <B>Use a static address</B>
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$address_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="address" SIZE="15" MAXLENGTH="15" VALUE="$CURRENT->{'address'}">
        </TD>

        <TD><DIV CLASS="nbody"><B>$netmask_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="netmask" SIZE="15" MAXLENGTH="15" VALUE="$CURRENT->{'netmask'}">
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>



  <!-- BEGIN _DHCP_ -->
  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Dynamic Interface (DHCP)</B></DIV></TD>
      </TR>
      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          DHCP is the Dynamic Host Control Protocol.  If you select the "Use
          DHCP to obtain network settings" checkbox then the machine will
          attempt to contact a DHCP server to obtain its network settings.  If
          you are on cable modem or a LAN that uses DHCP to delagate IP
          addresses, this is probably the option for you.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          <INPUT TYPE="RADIO" NAME="type" VALUE="dhcp" $dhcp_CHECKVAL> <B>Use DHCP to obtain network settings</B>
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="25%"><DIV CLASS="nbody"><B>$clobber_resolv_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Yes <INPUT TYPE="RADIO" NAME="clobber_resolv_dhcp" VALUE="yes" $pump_CLOBBERVAL_y>
          No  <INPUT TYPE="RADIO" NAME="clobber_resolv_dhcp" VALUE="no" $pump_CLOBBERVAL_n>
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>



  <!-- BEGIN _PPPoE_ -->
  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="4"><DIV CLASS="thead"><B>Dynamic Interface (PPPoE)</B></DIV></TD>
      </TR>
      <TR $cb>
        <TD COLSPAN="4"><DIV CLASS="nbody">
          PPPoE is the Point-to-Point Protocol over Ethernet.  If you select the
          "Use PPPoE to connect to network" checkbox then the machine will
          attempt to connect to the network using the PPPoE protocol.  In order
          to use PPPoE you must have a valid username and password (which you
          enter below).  If you are on a DSL connection thent his is probably
          the option for you.
        </DIV></TD>
      </TR>


      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4"><DIV CLASS="nbody">
          <INPUT TYPE="RADIO" NAME="type" VALUE="pppoe" $pppoe_CHECKVAL> <B>Use PPPoE to connect to network</B>
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="25%"><DIV CLASS="nbody"><B>$clobber_resolv_HELP</B></DIV></TD>
        <TD COLSPAN="3"><DIV CLASS="nbody">
          Yes <INPUT TYPE="RADIO" NAME="clobber_resolv_pppoe" VALUE="yes" $pppoe_CLOBBERVAL_y>
          No  <INPUT TYPE="RADIO" NAME="clobber_resolv_pppoe" VALUE="no" $pppoe_CLOBBERVAL_n>
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="25%"><DIV CLASS="nbody">
          <B>$pppoe_username_HELP</B>
        </DIV></TD>
        <TD WIDTH="25%">
          <INPUT TYPE="TEXT" NAME="pppoe_username" SIZE="20" VALUE="$PPPOE{'USER'}">
        </TD>
        <TD WIDTH="25%"><DIV CLASS="nbody">
          <B>$pppoe_password_HELP</B>
        </DIV></TD>
        <TD WIDTH="25%">
          <INPUT TYPE="TEXT" NAME="pppoe_password" SIZE="20" VALUE="$PPPOE{'PASSWORD'}">
        </TD>
      </TR>

      <TR $cb>
        <TD WIDTH="25%"><DIV CLASS="nbody">
          <B>$pppoe_acname_HELP</B>
        </DIV></TD>
        <TD WIDTH="25%">
          <INPUT TYPE="TEXT" NAME="pppoe_acname" SIZE="20" VALUE="$PPPOE{'ACNAME'}">
        </TD>
        <TD WIDTH="25%"><DIV CLASS="nbody">
          <B>$pppoe_servicename_HELP</B>
        </DIV></TD>
        <TD WIDTH="25%">
          <INPUT TYPE="TEXT" NAME="pppoe_servicename" SIZE="20" VALUE="$PPPOE{'SERVICENAME'}">
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4">
$iface_SUBMIT
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");
