#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: edit_resolv.cgi,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";
  &ReadParse();

  ###  Setup local variables.
  my ($HOSTNAME, $SEARCH);

  $HOSTNAME  =  &GetHostname();
  $SEARCH    =  &GetSearchDomains();


  ###  Print the usual header.
  &header("Network Configuration :: DNS Client Configuration", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_resolv.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Network Configuration</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can define the machines search domains (domains appended to
      ambiguous DNS queries).  You can also define what DNS servers it should
      use for DNS queries.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"> <B>Hostname and Search Domains</B> </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>Hostname</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="hostname" VALUE="$HOSTNAME" SIZE="40">
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>Search Domains</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="search" VALUE="$SEARCH" SIZE="40">
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"> <B>DNS Servers</B> </DIV></TD>
      </TR>

EOF


  ###
  ###  Iterate through and display all the nameservers
  ###  Display an empty box at the end for them to add one.
  ###
  my ($cnt); $cnt = 0;
  foreach my $s (&GetDNSServers()) {
    my ($enum);

    if ($DNSSERVER_ENUMERATION[$cnt]) { $enum = $DNSSERVER_ENUMERATION[$cnt]; }
    else                              { $enum = "Other Nameserver"; }

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$enum</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="dnsserver_$cnt" SIZE="15" MAXLENGTH="15" VALUE="$s">
        </TD>
      </TR>
EOF

    $cnt++;
  }

  my ($enum);
  if ($DNSSERVER_ENUMERATION[$cnt]) { $enum = $DNSSERVER_ENUMERATION[$cnt]; }
  else                              { $enum = "Other Nameserver"; }
  print "      <TR $cb>\n";
  print "        <TD><DIV CLASS=\"nbody\"><B>$enum</B></DIV></TD>\n";
  print "        <TD>\n";
  print "          <INPUT TYPE=\"TEXT\" SIZE=\"15\" MAXLENGTH=\"15\" NAME=\"";
  print "new_dnsserver\">\n";
  print "        </TD>\n";
  print "      </TR>\n\n";


  ###  Print the rest of the HTML.
  print <<EOF;
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" VALUE="Save Configuration">
        </DIV></TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
  </FORM>
</CENTER>
EOF

  ###  Print the standard footer.
  &ryanFooter("index.cgi");
