#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: edit_route.cgi,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";
  &ReadParse();

  ###  Define local variables.
  my ($ROUTE, $route_HEADER, $route_TEXT, $route_SELECT);

  ###  Setup local variables.
  if ($in{'new'}) {
    $ROUTE         =  undef;
    $route_HEADER  =  "Define New Static Route";
    $route_TEXT    =  "Below you can define a new static route.";
    $route_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="create" VALUE="Define Route">
        </DIV></TD>
      </TR>
      </TABLE>
EOF
  }
  else {
    $ROUTE         = &GetRouteRef($in{'lineno'});
    $route_HEADER  = "Edit Static Route";
    $route_TEXT    =  "Below you can edit or delete an existing static route.";
    $route_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="LEFT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="delete" VALUE="Delete Route">
        </DIV></TD>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="save" VALUE="Save Route">
        </DIV></TD>
      </TR>
      </TABLE>
EOF
  }


  ###  Print the usual header.
  &header("Network Configuration :: Routing Configuration :: $route_HEADER", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_route.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="lineno" VALUE="$in{'lineno'}">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="3"><B><DIV CLASS="ttitle">Network Configuration</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="3"><DIV CLASS="nbody">
      $route_TEXT
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD><DIV CLASS="thead"> <B> Network </B> </DIV></TD>
        <TD><DIV CLASS="thead"> <B> Netmask </B> </DIV></TD>
        <TD><DIV CLASS="thead"> <B> Device </B> </DIV></TD>
      </TR>

      <TR $cb>
        <TD><INPUT TYPE="TEXT" NAME="network" VALUE="$ROUTE->{'network'}" SIZE="15" MAXLENGTH="15"></TD>
        <TD><INPUT TYPE="TEXT" NAME="netmask" VALUE="$ROUTE->{'netmask'}" SIZE="15" MAXLENGTH="15"></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="device">
EOF


  ###  Build up the interface select.
  foreach my $j (sort ifacesort &ReadInterfaces()) {
    next if (($j->{'virtual'}) ||
             ($j->{'interface'} eq "lo"));

    print "            <OPTION VALUE=\"$j->{'interface'}\" ";
      if ($r->{'device'} eq $j->{'interface'})  { print "SELECTED"; }
    print ">$j->{'interface'} ($j->{'address'})</A>\n";
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="3">
$route_SUBMIT
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
  </FORM>
</CENTER>
EOF

  ###  Print the standard footer.
  &ryanFooter("list_routes.cgi");
