#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: edit_virtual_interface.cgi,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($CURRENT, $iface_HEADER, $iface_TEXT, $iface_SUBMIT);
  my ($real_interface_HELP, $address_HELP, $netmask_HELP);

  ###  Setup local variables.
  $real_interface_HELP  =  &hlink("Attach To", "network_real_interface");
  $address_HELP         =  &hlink("IP Address", "network_address");
  $netmask_HELP         =  &hlink("Netmask", "network_netmask");

  ###  Setup some specific variables for creation/edition.
  if ($in{'new'}) {
    $CURRENT       =  undef;
    $iface_HEADER  =  "Define New";
    $iface_TEXT    =  "Below you can define a new virtual interface.";
    $iface_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="create" VALUE="Define Address">
        </DIV></TD>
      </TR>
      </TABLE>
EOF
  }
  else {
    $iface_HEADER  =  "Edit";
    $iface_TEXT    =  "Below you can edit or delete an existing virtual interface.";
    $iface_SUBMIT  =<<EOF;
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR>
        <TD ALIGN="LEFT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="delete" VALUE="Delete Address">
        </DIV></TD>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=\"SUBMIT\" NAME="save" VALUE="Save Address">
        </DIV></TD>
      </TR>
      </TABLE>
EOF

    foreach my $i (&ReadInterfaces) {
      if ($i->{'interface'} eq $in{'iface'}) { $CURRENT = $i; }
    }
  }


  ###  Print the usual header.
  &header("Network Configuration :: $iface_HEADER Virtual Address", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_virtual_interface.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="iface" VALUE="$in{'iface'}">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Interface Setup</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      $iface_TEXT
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb><TD COLSPAN="4"><DIV CLASS="thead"><B>$iface_HEADER Virtual Address</B></DIV></TD></TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$real_interface_HELP</B></DIV></TD>
        <TD COLSPAN="3"><DIV CLASS="toolfont">
          <SELECT NAME="real_interface">
EOF


  ###  Display all read interfaces as candidates to "attach to."
  foreach my $i (sort ifacesort &ReadInterfaces()) {
    my ($address);

    next if (($i->{'virtual'}) ||
             ($i->{'interface'} eq "lo") ||
             ($i->{'type'} ne 'static'));

    if (($in{'master'} eq $i->{'interface'}) ||
        ($in{'iface'} =~ m/^$i->{'interface'}/)) {

      print "            <OPTION VALUE=\"$i->{'interface'}\" SELECTED>";
      print "$i->{'interface'} ($i->{'address'})</A>\n";
    }
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$address_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="address" SIZE="15" MAXLENGTH="15" VALUE="$CURRENT->{'address'}">
        </TD>

        <TD><DIV CLASS="nbody"><B>$netmask_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="netmask" SIZE="15" MAXLENGTH="15" VALUE="$CURRENT->{'netmask'}">
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4"> 
$iface_SUBMIT
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");
