#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: index.cgi,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "network-lib.pl";

  ###  Print the usual header.
  &header("Network Configuration", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Interface Setup</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is a listing of all configured interfaces.  Click on an interface
      to change its configuration.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Name</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>IP Address</B></DIV></TD>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Type</B></DIV></TD>
      </TR>

EOF


  ###  Display each interface.
  foreach my $i (sort ifacesort &ReadInterfaces()) {
    my ($address, $link, $spacer);

    ###  Skip loopback.
    next if ($i->{'interface'} eq "lo");

    ###  Setup some pretty variables.
    if ($i->{'virtual'}) {
      $spacer    =  "&nbsp;&nbsp;&nbsp;";
      $link      =  "<A HREF=\"edit_virtual_interface.cgi?iface=";
      $link     .=  "$i->{'interface'}\">$i->{'interface'}</A>";
    } else {
      $spacer    =  "";
      $link      =  "<A HREF=\"edit_physical_interface.cgi?iface=";
      $link     .=  "$i->{'interface'}\">$i->{'interface'}</A>";

    }

    ###  More pretty variables.
    if ($i->{'type'} ne 'static') { $address = "n/a"; }
    else                          { $address = $i->{'address'}; }

    ###  Finally, print the HTML.
    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody">$spacer<B>$link</B></DIV></TD>
        <TD><DIV CLASS="nbody">$address</DIV></TD>
        <TD><DIV CLASS="nbody">$INTERFACE_TYPES{$i->{'type'}}</DIV></TD>
EOF

    ###  Interface is real and static, so offer virtual creation.
    if ((! $i->{'virtual'}) && ($i->{'type'} eq "static")) {
      print "        <TD><DIV CLASS=\"nbody\"><B><A HREF=\"edit_virtual_";
      print "interface.cgi?new=1&master=$i->{'interface'}\">[&nbsp;New&nbsp;";
      print "Virtual&nbsp;Address&nbsp;]</A></B></DIV></TD>\n";
    } else {
      print "        <TD> &nbsp; </TD>\n";
    }
    print "      </TR>\n\n";
  }


  ###  More HTML.
  print <<EOF;
      <TR $cb> <TD COLSPAN="4"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="4" ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="edit_physical_interface.cgi?new=1">[ Define New Physical Interface ]</A>
        </B></DIV></TD>
      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
  </TABLE>


  <!-- BEGIN "Network Configuration" -->
  <P><TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Network Configuration</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can define static routes, where this machine should send DNS
      queries, and static host addresses.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="list_routes.cgi"> Routing Configuration </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Manipulate static routes and your machines default route.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD VALIGN="TOP"><DIV CLASS="nbody"><B>
          <A HREF="edit_resolv.cgi"> Hostname and DNS Client Configuration </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Define this machines hostname and nameservers.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="edit_hosts.cgi"> Define Static Host Addresses </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Create, modify, and remove static host address records.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="do_restart_networking.cgi"> Restart Networking </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Bring up/down interfaces and make routing changes active.
        </DIV></TD>
      </TR>


      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A onClick='window.open("network_help.cgi", "help", "toolbar=no,menubar=no,scrollbars=yes,width=400,height=450,resizable=yes"); return false' HREF="network_help.cgi">[ Network Configuration Help ]</A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          View the help page for this module.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("/SystemManager/");

