#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: list_routes.cgi,v 1.2 2002/04/23 20:57:18 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "network-lib.pl";

  ###  Print the usual header.
  &header("Network Configuration :: Routing Configuration", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><B><DIV CLASS="ttitle">Network Configuration</DIV></B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can perform various route manipulation functions.  Please note
      that <B>changes will not take effect until you restart networking</B>.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Static Routes</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      A <B>Static Route</B> is an explictly defined route.  When talking to the
      network your machine will check these routes and, if there are none that
      match, will fall back to sending it out the default route (see below).
    </TD>
  </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR $tb>
        <TD><DIV CLASS="thead"><B>Network / Netmask</B></DIV></TD>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Device</B></DIV></TD>
      </TR>

EOF


  ###  List all of our static routes.
  my ($cnt); $cnt = 0;
  foreach my $r (&ListStaticRoutes()) {
    $cnt++;

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody">$r->{'network'} / $r->{'netmask'}</DIV></TD>
        <TD><DIV CLASS="nbody">$r->{'device'}</DIV></TD>
        <TD><DIV CLASS="nbody">
          <A HREF="edit_route.cgi?lineno=$r->{'lineno'}"><B>[ Edit ]</B></A>
        </DIV></TD>
      </TR>
EOF
  }

  ###  If we do not have any routes, tell them.
  if (! $cnt) {
    print <<EOF;
      <TR $cb>
        <TD COLSPAN="3"><DIV CLASS="nbody"><B>There are no static routes defined.</B></DIV></TD>
      </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="3" ALIGN="RIGHT"><DIV CLASS="nbody">
          <A HREF="edit_route.cgi?new=1"><B>[ New Static Route ]</B></A>
        </DIV></TD>

      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Default Route</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      <FORM ACTION="do_save_default_route.cgi" METHOD="POST">
      The <B>Default Route</B> is the "next hop" for all packets leaving
      this machine that are not caught by any other routing rules.  This
      IP address should be told to you by your system administrator.
    </DIV></TD>
  </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR $tb>
        <TD><DIV CLASS="thead"><B>Gateway</B></DIV></TD>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Device</B></DIV></TD>
      </TR>

      <TR $cb>
EOF


  ### Iterate over all the interfaces and capture our default route, if any.
  my ($tmp_lineno, $tmp_defgw); $tmp_lineno = $tmp_defgw = undef;
  foreach my $i (&ReadInterfaces()) {
    if ($i->{'DEFAULTROUTE'}) {
      $tmp_lineno = $i->{'DEFAULTROUTE_LINE'};
      $tmp_defgw  = $i->{'DEFAULTROUTE'};
    }
  }

  ###
  ### Print the Gateway/Device/Save line using values (if any) from above.
  ###
  print <<EOF;
        <TD>
          <INPUT TYPE="TEXT" SIZE="15" MAXLENGTH="15" NAME="defaultroute" VALUE="$tmp_defgw">
          <INPUT TYPE="HIDDEN" NAME="defaultroute_lineno" VALUE="$tmp_lineno">
        </TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="defaultroute_iface">
EOF

  ###  Build up the interface select.
  foreach my $j (sort ifacesort &ReadInterfaces()) {
    next if (($j->{'virtual'}) || ($j->{'interface'} eq "lo"));

    print "            <OPTION VALUE=\"$j->{'interface'}\" ";
    if ($i->{'interface'} eq $j->{'interface'})  { print "SELECTED"; }
    print ">$j->{'interface'} ($j->{'address'})</A>\n";
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
        <TD><DIV CLASS="toolfont">
          <INPUT TYPE="SUBMIT" VALUE="Save Default Route">
          <P></FORM>
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
</CENTER>
EOF

  ###  Print the standard footer.
  &ryanFooter("index.cgi");
