#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: general.cgi,v 1.1.1.2 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require './postfix-lib.pl';

  ###  Set up our help links.
  my $relayhost_HELP  =  &hlink("Send Outgoing Mail Via Host", "postfix_relayhost");
  my $smtpd_HELP      =  &hlink("Allow Incoming Mail", "postfix_smtpd");
  my $procmail_HELP   =  &hlink("Enable Procmail", "postfix_procmail");


  ###  Determine the current value of 'relayhost' and set accordingly.
  open POSTCONF, "/usr/sbin/postconf -v relayhost |";
    ($relayhost_value) = (<POSTCONF> =~ m/^relayhost\ =\ (.*)$/);
  close POSTCONF;

  if ($relayhost_value) { $sel_rh_1 = "CHECKED"; }
  else                  { $sel_rh_0 = "CHECKED"; }


  ###  Determine the current value of 'mailbox_command' and set accordingly.
  open POSTCONF, "/usr/sbin/postconf -v mailbox_command |";
    ($procmail_value) = (<POSTCONF> =~ m/^mailbox_command\ =\ (.*)$/);
  close POSTCONF;

  if ($procmail_value) { $sel_procmail_0 = "CHECKED"; }
  else                 { $sel_procmail_1 = "CHECKED"; }


  ###  Determine whether we currently have port 25 (smtpd) enabled.
  open MASTER, "/etc/postfix/master.cf";
    while (<MASTER>)
    {
      if ($_ =~ m/^smtp.*smtpd$/) { $sel_smtpd_0 = "CHECKED"; }
    }
  close SMTPD;

  $sel_smtpd_1 = "CHECKED" unless defined $sel_smtpd_0;


  ###  Print the standard header.
  &header("Mail Server Management :: Mail Server Configuration", 0);


  ###  Print out HTML.
  print <<EOF;
<FORM ACTION="do_general.cgi" METHOD="POST">
<CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Mail Server Management</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      If your machine is behind a firewall and cannot send mail directly to
      the Internet, then set "<B>Send outgoing mail via host</B>" to the
      Fully-Qualified Domain Name (FQDN) your machine should forward all
      outgoing mail to.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">

      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Mail Server Configuration</B></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$relayhost_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <INPUT TYPE="RADIO" NAME="relayhost_def" VALUE="0" $sel_rh_0>
            Deliver Directly</DIV>

          <INPUT TYPE="RADIO" NAME="relayhost_def" VALUE="1" $sel_rh_1>
            <INPUT TYPE="TEXT" NAME="relayhost" SIZE="45" VALUE="$relayhost_value">
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$smtpd_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <INPUT TYPE="RADIO" NAME="smtpd_def" VALUE="0" $sel_smtpd_0>
            Enabled

          <BR><INPUT TYPE="RADIO" NAME="smtpd_def" VALUE="1" $sel_smtpd_1>
            Disabled</DIV>
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD VALIGN="TOP"><DIV CLASS="nbody"><B>$procmail_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <INPUT TYPE="RADIO" NAME="procmail_def" VALUE="0" $sel_procmail_0>
            Enabled

          <BR><INPUT TYPE="RADIO" NAME="procmail_def" VALUE="1" $sel_procmail_1>
            Disabled</DIV>
        </TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE=SUBMIT VALUE="Save Options">
        </DIV></TD>
      </TR>

      </TABLE>
    </TD>
  </TR>
</TABLE><P></FORM>
EOF


  ###  Print the standard footer.
  &ryanFooter("index.cgi");
