#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: edit_miniconfig.cgi,v 1.2.4.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Include our library routines.
  require './sshd-lib.pl';

  ###  Define local variables.
  my (%CONFIG, $ListenAddress_HELP, $ListenAddress_ICB);
  my ($AllowUsers_HELP, $AllowUsers_UCB, $AllowGroups_HELP, $AllowGroups_GCB);
  my ($DenyUsers_HELP, $DenyUsers_UCB, $DenyGroups_HELP, $DenyGroups_GCB);

  ###  Setup local variables.
  %CONFIG              =  &ReadConfig();
  $PermitRootLogin_HELP = &hlink("Permit Root Login?",   "sshd_PermitRootLogin");
  $ListenAddress_HELP  =  mkEvalPopup('Interfaces');
  $AllowUsers_HELP     =  &hlink("Allow Users",  "sshd_AllowUsers");
  $AllowGroups_HELP    =  &hlink("Allow Groups", "sshd_AllowGroups");
  $DenyUsers_HELP      =  &hlink("Deny Users",   "sshd_DenyUsers");
  $DenyGroups_HELP     =  &hlink("Deny Groups",  "sshd_DenyGroups");
  $ListenAddress_ICB   =  &interface_chooser_button("ListenAddress", 1, 0);
  $AllowUsers_UCB      =  &user_chooser_button("AllowUsers", 1, 0);
  $AllowGroups_GCB     =  &group_chooser_button("AllowGroups", 1, 0);
  $DenyUsers_UCB       =  &user_chooser_button("DenyUsers", 1, 0);
  $DenyGroups_GCB      =  &group_chooser_button("DenyGroups", 1, 0);

  ###  Print our standard header.
  &header("Secure Shell Management :: Edit Secure Shell Configuration", 0);

  ###  Print our HTML.
  print <<EOF;
<FORM ACTION="write_configfile.cgi" METHOD="POST">
<CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>Secure Shell Management</B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
      <TR $tb>
        <TD COLSPAN=2><DIV CLASS=thead><B>Server Configuration</TD>
      </TR>
  
      <TR $cb>
        <TD COLSPAN=2><DIV CLASS=nbody>
          Below you can define specific users or groups that you wish to allow
          or deny access to.  If the box is left blank the access will be
          granted to all users, provided the appropriate access control rules
          are defined in the <B>Security</B> module.

          <P>Keep in mind that if you grant access to a specific user or group
          then <B>only</B> those users will be able to ssh to the machine.  Be
          careful not to lock yourself out.  These should only be modified if
          you know what you are doing!
C: |$CONFIG{'PermitRootLogin'}|
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $tb>
        <TD><DIV CLASS="thead"><B>Setting</B></TD>
        <TD><DIV CLASS="thead"><B>Value</B></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$PermitRootLogin_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <SELECT NAME="PermitRootLogin">
EOF

  #
  # Print OPTIONS for PermitRootLogin.
  #
  print "            <OPTION VALUE=\"yes\" ";
  print "SELECTED" if (($CONFIG{'PermitRootLogin'} =~ m/^yes/) ||
                       (! $CONFIG{'PermitRootLogin'}));
  print ">Enabled</OPTION>\n";
  print "            <OPTION VALUE=\"no\" ";
  print "SELECTED" if ($CONFIG{'PermitRootLogin'} =~ m/^no/);
  print ">Disabled</OPTION>\n";

  # More HTML.
  print <<EOF;
          </SELECT>
        </TD>
      </TR>
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$ListenAddress_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="ListenAddress" SIZE="30" VALUE="" DISABLED>
          $ListenAddress_ICB
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$AllowUsers_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="AllowUsers" SIZE="30" VALUE="$CONFIG{'AllowUsers'}">
          $AllowUsers_UCB
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$AllowGroups_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="AllowGroups" SIZE="30" VALUE="$CONFIG{'AllowGroups'}">
          $AllowGroups_GCB
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$DenyUsers_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="DenyUsers" SIZE="30" VALUE="$CONFIG{'DenyUsers'}">
          $DenyUsers_UCB
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$DenyGroups_HELP</A></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="DenyGroups" SIZE="30" VALUE="$CONFIG{'DenyGroups'}">
          $DenyGroups_GCB
        </TD>
      </TR>

      <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
          <INPUT TYPE="SUBMIT" VALUE="Write Configuration">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER>
</FORM>
EOF

  ###  Print our standard footer.
  &ryanFooter("index.cgi");

