#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: sshd-lib.pl,v 1.1.1.2 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Include global subroutines and &init_config().
  do "../../web-lib.pl";
  &init_config();

  ### ##########################################################################
  ### Global Variables
  ### ##########################################################################
  $SSHD_CONFIG      =  '/etc/ssh/sshd_config';
  $SSHD_INITSCRIPT  =  '/etc/init.d/sshd';



  ### ##########################################################################
  sub ReadConfig() {
    my (%C);

    open CONFIG, $SSHD_CONFIG;
      while (my $line = <CONFIG>)
      {
        my ($key, $value); chomp $line;

        ###  Skip empty and comment lines.
        next if (($line eq "") || ($line =~ m/^#/));

        ###  Split the key and value, and put in %C.
        ($key, $value) = split /\s+/, $line, 2; $C{$key} .= "$value ";
      }
    close CONFIG;

    return %C;
  }


  ### ##########################################################################
  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>  
ErrorEOF
  }


  ### ##########################################################################
  sub sshdCtl() {
    my ($rc); $rc = undef;

    my (%E); %E = %ENV; %ENV = ();
      if ($_[0] eq "start")      { $rc = system("$SSHD_INITSCRIPT start");    }
      elsif ($_[0] eq "stop")    { $rc = system("$SSHD_INITSCRIPT stop");     }
      elsif ($_[0] eq "restart") { $rc = system("$SSHD_INITSCRIPT restart");  }
    %ENV = %E;

    return $rc;
  }


  ### ##########################################################################
  sub DaemonStatus {
    $status = `/bin/netstat --inet -a -n`;

    if ($status =~ m/\:22\s+.*LISTEN/) {
      return 1;
    }
    else {
      return 0;
    }
  }


  ### ##########################################################################
  sub ValidUser {
    my ($username, $isValid);

    ($username) = @_;
    $isValid = 0;

    &obtain_lock("/etc/passwd");
    open PASSWD, "/etc/passwd";
      while (<PASSWD>) { if ($_ =~ m/^$username\:/) { $isValid = 1; } }
    close PASSWD;
    &release_lock("/etc/passwd");

    return $isValid;
  }






  ### ##########################################################################
  1;

