#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: write_configfile.cgi,v 1.3.2.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Include our library routines and populate %in.
  require './sshd-lib.pl';
  &ReadParse();


  ###  Setup local variables.
  my ($lref, @bewm_lines);
  my ($AllowUsers_LINE, $AllowGroups_LINE);
  my ($DenyUsers_LINE, $DenyGroups_LINE);
  my ($HAVE_AU, $HAVE_AG, $HAVE_DU, $HAVE_DG);

  ###  Define local variables.
  $HAVE_AU = 0; $HAVE_AG = 0; $HAVE_DU = 0; $HAVE_DG = 0;

    ###  Setup AllowUsers line.
    foreach my $u (split /\s+/, $in{'AllowUsers'}) {
      if (! defined(getpwnam($u))) {
        &PrintError("'$u' is not a valid user for Allow Users");
        exit;
      }

      $HAVE_AU = 1; $AllowUsers_LINE .= "$u ";
    }

    ###  Setup AllowGroups line.
    foreach my $g (split /\s+/, $in{'AllowGroups'}) {
      if (! defined(getgrnam($g))) {
        &PrintError("'$g' is not a valid user for Allow Groups");
        exit;
      }

      $HAVE_AG = 1; $AllowGroups_LINE .= "$g ";
    }

    ###  Setup DenyUsers line.
    foreach my $u (split /\s+/, $in{'DenyUsers'}) {
      if (! defined(getpwnam($u))) {
        &PrintError("'$u' is not a valid user for Deny Users");
        exit;
      }

      $HAVE_DU = 1; $DenyUsers_LINE .= "$u ";
    }

    ###  Setup DenyGroups line.
    foreach my $g (split /\s+/, $in{'DenyGroups'}) {
      if (! defined(getgrnam($g))) {
        &PrintError("'$g' is not a valid user for Deny Groups");
        exit;
      }

      $HAVE_DG = 1; $DenyGroups_LINE .= "$g ";
    }



  ###  Read the configuration file into $lref.
  $lref  =  &read_file_lines($SSHD_CONFIG);

    ###  Phase 1:  Populate @bewm_lines.
    for (my $i = 0; $i < @$lref; $i++) {
      if (@$lref[$i] =~ m/^AllowUsers/) { push @bewm_lines, $i; }
      if (@$lref[$i] =~ m/^AllowGroups/) { push @bewm_lines, $i; }
      if (@$lref[$i] =~ m/^DenyUsers/) { push @bewm_lines, $i; }
      if (@$lref[$i] =~ m/^DenyGroups/) { push @bewm_lines, $i; }
      if (@$lref[$i] =~ m/^PermitRootLogin/) { push @bewm_lines, $i; }
    }

    ###  Phase 2:  Remove all @bewm_lines;
    while (my $b = pop @bewm_lines) { splice @$lref, $b, 1; }

    ###  Phase 3:  Push new directives, if we want to.
    if ($HAVE_AU) { push @$lref, "AllowUsers $AllowUsers_LINE"; }
    if ($HAVE_AG) { push @$lref, "AllowGroups $AllowGroups_LINE"; }
    if ($HAVE_DU) { push @$lref, "DenyUsers $DenyUsers_LINE"; }
    if ($HAVE_DG) { push @$lref, "DenyGroups $DenyGroups_LINE"; }
    if ($in{'PermitRootLogin'}) {
      push @$lref, "PermitRootLogin $in{'PermitRootLogin'}";
    }

  ###  Finally, write the file back to disk.
  &flush_file_lines();


  ###  Restart the SSH daemon.
  &sshdCtl('restart');


  ###  Redirect back to the index page.
  &redirect("index.cgi");
