#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: chroot.cgi,v 1.2 2002/04/25 01:25:01 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "vsftpd-lib.pl";

  ###  Print the standard header.
  &header("FTP Server Configuration :: Define Chroot and Blacklist", 0, 0);

  ###  Set up local vars.
  my ($chroot_UCB, $chroot_list, $blacklist_UCB, $blacklist);


  ###  Build the little selector boxy thingy.
  $chroot_UCB     =  &user_chooser_button("chroot_list", 1);
  $blacklist_UCB  =  &user_chooser_button("blacklist", 1);

  ###  Build our current chroot list.
  open CHROOTLIST, $CONF_CHROOT_LIST;
    while (<CHROOTLIST>) { chomp; $chroot_list .= "$_ "; }
  close CHROOTLIST;

  ###  Build our current blacklist.  You can't use $_ in the EXPR for grep. :)
  open BLACKLIST, $CONF_BLACKLIST;
    while (<BLACKLIST>)
    {
      chomp; my $t = $_;
      if (! grep /^$t$/, @ALWAYS_DENY_LIST) { $blacklist .= "$t "; }

    }
  close BLACKLIST;


  ###  Now display the screen to the user.
  print <<EOF;

<P><CENTER>
  <FORM ACTION="do_chroot.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      FTP Server Configuration
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      "<B>chroot</B>" is a term used to say "change the root directory of this
      user to X."  By "chrooting" a user to their home directory you limit the
      amount of damage they can do to the system should a vulnerability be
      found, and you limit the files they can access (via FTP) to those in
      their home directory.  This is generally a good thing and should be used
      whenever possible.

      <P>This page allows you to define what users should be chrooted.  Any
      user not listed here will <B>not</B> be chrooted unless you have "Chroot
      All Local Users" on the <A HREF="tunables.cgi">Global Configuration</A>
      page.

      <P>The <B>blacklist</B> defines what users are not allowed to FTP into
      the machine.  If you have "Allow Local Logins" enabled in the <A
      HREF="tunables.cgi">Global Configuration</A>, and you would like to block
      access to certain users, select their username here.

      <P>Any changes made here will take effect <B>immediately</B>.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Chroot List</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>Blacklist</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD>
          <TABLE>
          <TR>
            <TD>
              <TEXTAREA WRAP="AUTO" NAME="chroot_list" ROWS="10" COLS="20">$chroot_list</TEXTAREA>
            </TD>
            <TD VALIGN="TOP">$chroot_UCB</TD>
          </TR>
          </TABLE>
        </TD>

        <TD>
          <TABLE>
          <TR>
            <TD>
              <TEXTAREA WRAP="AUTO" NAME="blacklist" ROWS="10" COLS="20">$blacklist</TEXTAREA>
            </TD>
            <TD VALIGN="TOP">$blacklist_UCB</TD>
          </TR>
          </TABLE>
        </TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" VALUE="Save Changes">
        </DIV></TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF

  ###  Print the standard footer.
  &ryanFooter("index.cgi");
