#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: do_tunables.cgi,v 1.1.1.1.4.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and read the input string.
  require "vsftpd-lib.pl";
  &ReadParse();


  ###  Do some basic input validation.
  if (! $in{'ftpd_banner'}) {
    &PrintError("Please enter a value for 'FTP Banner'"); exit;
  }
  elsif ($in{'ftpd_banner'} =~ m/[\`\=]/) {
    &PrintError("You have entered an invalid 'FTP Banner'"); exit;
  }

  elsif (! defined($in{'anon_max_rate'})) {
    &PrintError("Please enter a value for 'Max. Rate for Anonymous Users'"); exit;
  }
  elsif (! defined($in{'local_max_rate'})) {
    &PrintError("Please enter a value for 'Max. Rate for Local Users'"); exit;
  }
  elsif ($in{'anon_max_rate'} !~ m/^[0-9]+$/) {
    &PrintError("You have entered an invalid value for'Max. Rate for Anonymous Users'"); exit;
  }
  elsif ($in{'local_max_rate'} !~ m/^[0-9]+$/) {
    &PrintError("You have entered an invalid value for'Max. Rate for Local Users'"); exit;
  }

  ###  Convert k to b (bewm).
  my ($anon_max_rate_SAVE, $local_max_rate_SAVE);
  $anon_max_rate_SAVE   =  $in{'anon_max_rate'}  * 1024;
  $local_max_rate_SAVE  =  $in{'local_max_rate'} * 1024;

  ###
  ###  Make appropriate changes to /etc/vsftpd.conf.
  ###

  ###  Read in the file.
  my $lref  =  &read_file_lines($CONFIGURATION_FILE);

    ###  Iterate through the file, replacing lines as we go.
    for ($i = 0; $i < @$lref; $i++)
    {
      my $l  =  @$lref[$i];

      if ($l =~ m/^[#\ ]*anon_mkdir_write_enable\=.*$/)
      {
        @$lref[$i]  =  "anon_mkdir_write_enable=$in{'anon_mkdir_write_enable'}";
      }
      elsif ($l =~ m/^[#\ ]*anon_upload_enable\=.*$/)
      {
        @$lref[$i]  =  "anon_upload_enable=$in{'anon_upload_enable'}";
      }
      elsif ($l =~ m/^[#\ ]*anonymous_enable\=.*$/)
      {
        @$lref[$i]  =  "anonymous_enable=$in{'anonymous_enable'}";
      }
      elsif ($l =~ m/^[#\ ]*chroot_local_user\=.*$/)
      {
        @$lref[$i]  =  "chroot_local_user=$in{'chroot_local_user'}";
      }
      elsif ($l =~ m/^[#\ ]*local_enable\=.*$/)
      {
        @$lref[$i]  =  "local_enable=$in{'local_enable'}";
      }
      elsif ($l =~ m/^[#\ ]*write_enable\=.*$/)
      {
        @$lref[$i]  =  "write_enable=$in{'write_enable'}";
      }

      ###  This is the only char* setting we touch.
      elsif ($l =~ m/^[#\ ]*ftpd_banner\=.*$/)
      {
        @$lref[$i]  =  "ftpd_banner=$in{'ftpd_banner'}";
      }

      ###  These are the only numeric setting we touch.
      elsif ($l =~ m/^[#\ ]*local_umask\=.*$/)
      {
        @$lref[$i]  =  "local_umask=$in{'local_umask'}";
      }
      elsif ($l =~ m/^[#\ ]*anon_umask\=.*$/)
      {
        @$lref[$i]  =  "anon_umask=$in{'anon_umask'}";
      }
      elsif ($l =~ m/^[#\ ]*anon_max_rate\=.*$/)
      {
        @$lref[$i]  =  "anon_max_rate=$anon_max_rate_SAVE";
      }
      elsif ($l =~ m/^[#\ ]*local_max_rate\=.*$/)
      {
        @$lref[$i]  =  "local_max_rate=$local_max_rate_SAVE";
      }
    }

  ###  Write the file.
  &flush_file_lines();


  ###  Go back to the index.
  &redirect("index.cgi");
