#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: tunables.cgi,v 1.2.4.1 2003/04/14 19:19:05 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "vsftpd-lib.pl";

  ###  Print the standard header.
  &header("FTP Server Configuration :: Global Configuration", 0, 0);

  ###  Obtain our current configuration.
  my (%config);
  %config = &ReadConfiguration();


  ###  Define local variables.
  my ($anonymous_enable_HELP, $local_enable_HELP, $chroot_local_user_HELP);
  my ($write_enable_HELP, $anon_upload_enable_HELP, $interface_HELP);
  my ($anon_mkdir_write_enable_HELP, $local_umask_HELP, $ftpd_banner_HELP);
  my ($anonymous_enable_SELECT, $local_enable_SELECT, $local_umask_SELECT);
  my ($chroot_local_user_SELECT, $write_enable_SELECT, $interface_ICB);
  my ($anon_upload_enable_SELECT, $anon_mkdir_write_enable_SELECT);
  my ($anon_max_rate_HELP, $local_max_rate_HELP);
  my ($anon_max_rate_VALUE, $local_max_rate_VALUE);
  my ($anon_umask_HELP, $anon_umask_SELECT);

  ###  Setup local variables.
  $anonymous_enable_HELP           =  &hlink("Allow Anonymous Logins", "vsftpd_anonymous_enable");
  $local_enable_HELP               =  &hlink("Allow Local Logins", "vsftpd_local_enable");
  $chroot_local_user_HELP          =  &hlink("Chroot All Local Users", "vsftpd_chroot_local_user");
  $write_enable_HELP               =  &hlink("Enable User Uploads", "vsftpd_write_enable");
  $anon_upload_enable_HELP         =  &hlink("Allow Anonymous Uploads", "vsftpd_anon_upload_enable");
  $anon_mkdir_write_enable_HELP    =  &hlink("Allow Anonymous MKDIR", "vsftpd_anon_mkdir_write_enable");
  $local_umask_HELP                =  &hlink("Create Permissions (Users)", "vsftpd_local_umask");
  $anon_umask_HELP                 =  &hlink("Create Permissions (Anonymous)", "vsftpd_anon_umask");
  $ftpd_banner_HELP                =  &hlink("FTP Banner", "vsftpd_ftpd_banner");
  $interface_HELP                  =  mkEvalPopup('Interface to Listen On');
  $anon_max_rate_HELP              =  &hlink("Max. Rate for Anonymous Users", "vsftpd_anon_max_rate");
  $local_max_rate_HELP             =  &hlink("Max. Rate for Local Users", "vsftpd_local_max_rate");
  $anonymous_enable_SELECT         =  &BuildSelect("anonymous_enable", $config{'anonymous_enable'});
  $local_enable_SELECT             =  &BuildSelect("local_enable", $config{'local_enable'});
  $chroot_local_user_SELECT        =  &BuildSelect("chroot_local_user", $config{'chroot_local_user'});
  $write_enable_SELECT             =  &BuildSelect("write_enable", $config{'write_enable'});
  $anon_upload_enable_SELECT       =  &BuildSelect("anon_upload_enable", $config{'anon_upload_enable'});
  $anon_mkdir_write_enable_SELECT  =  &BuildSelect("anon_mkdir_write_enable", $config{'anon_mkdir_write_enable'});
  $local_umask_SELECT              =  &BuildSelect("local_umask", $config{'local_umask'});
  $anon_umask_SELECT               =  &BuildSelect("anon_umask", $config{'anon_umask'});
  $interface_ICB                   =  &interface_chooser_button("iface", 0, 0);

  ###  Convert b to k (bewm).
  $anon_max_rate_VALUE     =  $config{'anon_max_rate'}  / 1024;
  $local_max_rate_VALUE    =  $config{'local_max_rate'} / 1024;


  ###  Now display the screen to the user.
  print <<EOF;

<P><CENTER>
  <FORM ACTION="do_tunables.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      FTP Server Configuration
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can define global options.  The options set here will effect
      every connection made to the FTP service.  If you are unsure of an option,
      please click on the help link for a detailed explination.

      <P>Any changes made here will take effect <B>immediately</B>.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Setting</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>Value</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$anonymous_enable_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$anonymous_enable_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$local_enable_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$local_enable_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$chroot_local_user_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$chroot_local_user_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$write_enable_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$write_enable_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$anon_upload_enable_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$anon_upload_enable_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$anon_mkdir_write_enable_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$anon_mkdir_write_enable_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$local_umask_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$local_umask_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$anon_umask_HELP</B></DIV></TD>
        <TD><DIV CLASS="nbody">
$anon_umask_SELECT
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$ftpd_banner_HELP</B></DIV></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="ftpd_banner" VALUE="$config{'ftpd_banner'}" SIZE="30" MAXLENGTH="75">
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$interface_HELP</B></DIV></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="iface" SIZE="15" MAXLENGTH="15" DISABLED> $interface_ICB
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$anon_max_rate_HELP</B></DIV></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="anon_max_rate" VALUE="$anon_max_rate_VALUE" SIZE="5">&nbsp;&nbsp;<FONT FACE="Arial,Helvetica,Sans-Serif">k/sec</FONT>
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$local_max_rate_HELP</B></DIV></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="TEXT" NAME="local_max_rate" VALUE="$local_max_rate_VALUE" SIZE="5">&nbsp;&nbsp;<FONT FACE="Arial,Helvetica,Sans-Serif">k/sec</FONT>
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" VALUE="Save Changes">
        </DIV></TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF

  ###  Print the standard footer.
  &ryanFooter("index.cgi");
