#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.                                        
 | $Id: vsftpd-lib.pl,v 1.1.1.1 2001/12/11 06:50:40 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 |
 | PURPOSE:  Functions for the vsftpd sub-module.
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  do "../../web-lib.pl";
  &init_config();

  ### ##########################################################################
  ### Global Variables
  ### ##########################################################################
  $CONFIGURATION_FILE  =  '/etc/vsftpd.conf';
  $CONF_CHROOT_LIST    =  '/etc/vsftpd.chroot_list';
  $CONF_BLACKLIST      =  '/etc/ftpusers';
  $CONF_XINETD         =  '/etc/xinetd.d/ftp';

  @ALWAYS_DENY_LIST = ( 'root', 'bin', 'daemon', 'adm', 'sync', 'shutdown',
                        'halt', 'mail', 'operator', 'nobody', 'named',
                        'postfix', 'mysql', 'webd', 'ftp'
                      );


  ### ##########################################################################
  sub ReadConfiguration()
  {
    my (%config);

    open CONFIG, $CONFIGURATION_FILE;
      while (<CONFIG>)
      {
        chomp;
        if ($_ =~ m/^([^\=]+)\=([^=]+)$/) { $config{$1} = $2; }
      }
    close CONFIG;

    return %config;
  }


  ### ##########################################################################
  sub BuildSelect()
  {
    my ($tmp, $tunable, $value);
    ($tunable, $value) = @_;

    ###  The umask is the only tunable we need a non YES/NO for.
    if (($tunable eq "local_umask") || ($tunable eq "anon_umask"))
    {
      $tmp  =  "<SELECT NAME=\"$tunable\">\n";

      $tmp .=  "  <OPTION VALUE=\"027\" ";
      $tmp .= "SELECTED" if ($value eq "027");
      $tmp .= ">Owner Readable</OPTION>\n";

      $tmp .=  "  <OPTION VALUE=\"022\" ";
      $tmp .= "SELECTED" if ($value ne "027");
      $tmp .= ">World Readable</OPTION>\n";

      $tmp .=  "</SELECT>\n";
    }
    else
    {
      $tmp  =  "<SELECT NAME=\"$tunable\">\n";

      $tmp .=  "  <OPTION VALUE=\"YES\" ";
      $tmp .= "SELECTED" if ($value eq "YES");
      $tmp .= ">Enable</OPTION>\n";

      $tmp .=  "  <OPTION VALUE=\"NO\" ";
      $tmp .= "SELECTED" if ($value ne "YES");
      $tmp .= ">Disable</OPTION>\n";

      $tmp .=  "</SELECT>\n";
    }

    return $tmp;
  }


  ### ##########################################################################
  sub GetCurrentInterface() {
    my ($rv, $lineno);  $lineno = -1;

    open XINETD, $CONF_XINETD;
      while (my $line = <XINETD>) {
        $lineno++;  chomp $line;

        if ($line =~ m/^(.*)interface\s+=\s+(.*)$/) {
          $rv->{'comment'} =  1 if ($1 =~ m/#/);
          $rv->{'lineno'}  =  $lineno;
          $rv->{'iface'}   =  $2;
        }
      }
    close XINETD;

    return $rv;
  }


  ### ##########################################################################
  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>
ErrorEOF
  }

