#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: index.cgi,v 1.5.4.3 2003/04/22 20:52:42 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and &init_config().
  require './web-lib.pl';
  &init_config();


  ###
  ###  Take the user to INITCONFIG if 'unconfigured' is present.
  ###
  if (-f "/usr/webtool/unconfigured") {
    &redirect("/INITCONFIG/");
    exit;
  }


  ###
  ### Get the EAS's config and build the "popup link."
  ###
  my %EAS_CONFIG; &read_file("/etc/webtool/EAS/config", \%EAS_CONFIG);
  $EAS_CONFIG{'eas_menubar'} = 'no'     if (! $EAS_CONFIG{'eas_menubar'});
  $EAS_CONFIG{'eas_scrollbars'} = 'yes' if (! $EAS_CONFIG{'eas_scrollbars'});
  $EAS_CONFIG{'eas_width'} = 600        if (! $EAS_CONFIG{'eas_width'});
  $EAS_CONFIG{'eas_height'} = 450       if (! $EAS_CONFIG{'eas_height'});

  my $EAS_LINK = "<A onClick='window.open(\"/EAS/eas.cgi\", \"eas\", \"toolbar=no,menubar=$EAS_CONFIG{'eas_menubar'},scrollbars=$EAS_CONFIG{'eas_scrollbars'},width=$EAS_CONFIG{'eas_width'},height=$EAS_CONFIG{'eas_height'},resizable=yes\"); return false' HREF=\"/EAS/eas.cgi\">";


  # Show the appropriate GDSN image.
  my $GDSN_IMAGE = &get_gdsn_index_image();

  ###
  ###  Print the standard header.
  ###
  &header("The Guardian Digital WebTool -- Guardian Digital, Inc.", 0);


  ###
  ###  If we have the VHost module, then print all the images.
  ###
  if (-d "/usr/webtool/VHost") {
    print <<EOF;

    <TABLE BORDER="0" WIDTH="620" CELLPADDING="0" ALIGN="CENTER">
    <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
    <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="VHost/"><IMG SRC="images/Index-VHost.gif" BORDER="0"></A>
      </TD>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemManager/"><IMG SRC="images/Index-SystemManager.gif" BORDER="0"></A>
      </TD>
      <TD ALIGN="CENTER" WIDTH="33%">
        $EAS_LINK<IMG SRC="images/Index-EAS.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>

    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="Security/"><IMG SRC="images/Index-Security.gif" BORDER="0"></A>
      </TD>

      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="GDSN/"><IMG SRC="images/$GDSN_IMAGE" BORDER="0"></A>
      </TD>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemBackup/"><IMG SRC="images/Index-SystemBackup.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
  </TABLE><P>

EOF
  }

  ###
  ###  We don't have the VHost module, so leave it out.
  ###
  else {
    print <<EOF;

    <TABLE BORDER="0" WIDTH="620" CELLPADDING="0" ALIGN="CENTER">
    <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>
    <TR> <TD COLSPAN="3"> &nbsp; </TD> </TR>

    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemManager/"><IMG SRC="images/Index-SystemManager.gif" BORDER="0"></A>
      </TD>

      <TD WIDTH="33%">&nbsp;</TD>

      <TD ALIGN="CENTER" WIDTH="33%">
        $EAS_LINK<IMG SRC="images/Index-EAS.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>

    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="Security/"><IMG SRC="images/Index-Security.gif" BORDER="0"></A>
      </TD>

      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="GDSN/"><IMG SRC="images/Index-GDSN.gif" BORDER="0"></A>
      </TD>

      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemBackup/"><IMG SRC="images/Index-SystemBackup.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
  </TABLE><P>

EOF
  }


  ###
  ###  Print the standard footer with logout link.
  ###
  &ryanFooter("session_login.cgi?logout=1");

################################################################################
sub get_gdsn_index_image() {
  my @rv  = ('Index-GDSN.gif', 'Index-GDSN-alert.gif');
  my $rvi = 0;

  # Read config and set $rvi accordingly.
  my %GDSN; &read_file("/etc/webtool/GDSN/config", \%GDSN);

  if ($GDSN{'activation_code_expired'} == 1 ||
      ! $GDSN{'configured'} || ! $GDSN{'activated'}) { $rvi = 1; }

  # Finally return our image.
  return $rv[$rvi];
}
